"""
Best viewed in a loooong window
"""
import os
import sys
import widgets

#-----------------------------------------------------------------------
create_list = (
    ( ("Atmosphere",),
      #{Arguments for widget},          widget type,         (Optional eventtype, optional eventhandler)
      ({"name":"atmosphere_file", "colour":"RED"}, widgets.OpenButton, (),), 
      ({"name":"rh_file",}, widgets.OpenButton, (),), 
      ({"name":"altitude"   , "max_val":None,    "min_val":0, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"day_of_year",  "max_val":None, "min_val":0,}, widgets.IntSpinner, (),),
      ({"name":"ozone_column"   , "max_val":None,    "min_val":0, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"pressure"   , "max_val":None,    "min_val":0, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"sza"   , "max_val":100,    "min_val":0, "increment":0.1, "colour":"RED"},  widgets.FloatSpinner, ()),
      ({"name":"sza_file"}, widgets.OpenButton, ()),
      ({"name":"phi0"  , "max_val":360,    "min_val":0, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"f11_mixing_ratio"}, widgets.FloatSpinner, ()),
      ({"name":"f12_mixing_ratio"}, widgets.FloatSpinner, ()),
      ({"name":"f22_mixing_ratio"}, widgets.FloatSpinner, ()),
#aky17092009      ({"name":"no2_column_du", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
      ({"name":"rayleigh_depol", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
      ({"name":"ch4_mixing_ratio"}, widgets.FloatSpinner, ()),
      ({"name":"o2_mixing_ratio"}, widgets.FloatSpinner, ()),
      ({"name":"n2o_mixing_ratio"}, widgets.FloatSpinner, ()),
#aky17092009      ({"name":"no2_column_moleccm"}, widgets.OnOff, ()),
      ({"name":"h2o_mixing_ratio"}, widgets.FloatSpinner, ()),
      ({"name":"co2_mixing_ratio"}, widgets.FloatSpinner, ()),
      ({"name":"h2o_precip"}, widgets.FloatSpinner, ()),
      ({"name":"reverse"}, widgets.OnOff, ()),
      ({"name":"zout_interpolate"}, widgets.OnOff, ()),
      ({"name":"refractive_index_file"}, widgets.OpenButton, ()),
      ),
    ( ("Spectral",), 
      ({"name":"solar_file", "colour":"RED"}, widgets.OpenButton, ()),
      ({"name":"wavelength",   "spins":["start", "stop"], "colour":"RED"}, widgets.FloatSpinTogether, ()),
      ({"name":"slit_function_file",}, widgets.OpenButton, ()),
      ({"name":"spline", "spins":["min", "max", "step"], "min_val":0} , widgets.FloatSpinTogether, ()),
      ({"name":"spline_file"}, widgets.OpenButton, ()),
      ({"name":"correlated_k", "choices":["None", "Kato", "Kato2", "Kato2.96", "Fu", "AVHRR_KRATZ", "LOWTRAN", "SBDART"]}, widgets.Choice, ()),
      ({"name":"filter_function_file",}, widgets.OpenButton, ()),
      ({"name":"transmittance_wl_file",}, widgets.OpenButton, ()),
      ({"name":"wavelength_index" , "spins":["index 1", "index 2"],"max_val":None, "min_val":0} , widgets.IntSpinner, ()),
      ({"name":"thermal_bands_file"}, widgets.OpenButton, ()),
      ),
    ( ("Aerosol",), 
      ({"name":"aerosol_default"  , } , widgets.OnOff, ()),
      ({"name":"aerosol_angstrom" , "spins":["alpha", "beta"],"max_val":None, "min_val":0, "increment":0.05} , widgets.FloatSpinner, ()),
      ({"name":"aerosol_haze"      , "max_val":6,    "min_val":1,},  widgets.IntSpinner, ()),
      ({"name":"aerosol_season"    , "max_val":2,    "min_val":1,},  widgets.IntSpinner, ()),
      ({"name":"aerosol_vulcan"    , "max_val":4,    "min_val":1,},  widgets.IntSpinner, ()),
      ({"name":"aerosol_visibility", "max_val":None, "min_val":0,},  widgets.FloatSpinner, ()),
      ({"name":"aerosol_set_ssa"   , "max_val":1,    "min_val":0, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"aerosol_set_gg"    , "max_val":1,    "min_val":-1,"increment":0.1}, widgets.FloatSpinner, ()),
      ({"name":"aerosol_set_tau"   , "max_val":None, "min_val":0, "increment":1},  widgets.FloatSpinner, ()),
      ({"name":"aerosol_set_tau550", "max_val":None, "min_val":0, "increment":1},  widgets.FloatSpinner, ()),
      ({"name":"aerosol_tau_file",}, widgets.OpenButton, ()),
      ({"name":"aerosol_moments_file",}, widgets.OpenButton, ()),
      ({"name":"aerosol_files",}, widgets.OpenButton, ()),
      ({"name":"aerosol_sizedist_file",}, widgets.OpenButton, ()),
      ({"name":"aerosol_no_scattering"}, widgets.OnOff, ()),
      ({"name":"aerosol_scale_tau"}, widgets.FloatSpinner, ()),
      ({"name":"aerosol_scale_ssa"}, widgets.FloatSpinner, ()),
      ({"name":"aerosol_species_library"}, widgets.OpenButton, ()),
      ({"name":"aerosol_refrac_file"}, widgets.OpenButton, ()),
      ({"name":"aerosol_ssa_file"}, widgets.OpenButton, ()),
      ({"name":"aerosol_gg_file"}, widgets.OpenButton, ()),
      ),
    ( ("Clouds",), 
      ({"name":"wc_file",}, widgets.OpenButton, ()),
      ({"name":"wc_properties", "choices":["None", "hu", "echam4", "mie"]}, widgets.Choice, ()),
      ({"name":"wc_ipa_files",}, widgets.OpenButton, ()),
      ({"name":"wc_cloudcover"   , "max_val":None,    "min_val":0, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"wc_set_ssa"   , "max_val":1,    "min_val":0, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"wc_set_gg"    , "max_val":1,    "min_val":-1,"increment":0.1}, widgets.FloatSpinner, ()),
      ({"name":"wc_set_tau"   , "max_val":None, "min_val":0, "increment":1},  widgets.FloatSpinner, ()),
      ({"name":"wc_set_tau550", "max_val":None, "min_val":0, "increment":1},  widgets.FloatSpinner, ()),
      ({"name":"wc_files"}, widgets.OpenButton, ()),
      ({"name":"wc_scale_gg"}, widgets.FloatSpinner, ()),
      ({"name":"wc_level"}, widgets.OnOff, ()),
      ({"name":"wc_no_scattering"}, widgets.OnOff, ()),
      ({"name":"wc_layer"}, widgets.OnOff, ()),
      ({"name":"wc_properties_interpolate"}, widgets.OnOff, ()),
      ({"name":"wc_ipa"}, widgets.OpenButton, ()),
      ({"name":"wc_scale_ssa"}, widgets.FloatSpinner, ()),
      ({"name":"ic_ipa_files"}, widgets.OpenButton, ()),
      ({"name":"ic_set_ssa"}, widgets.FloatSpinner, ()),
      ({"name":"ic_no_scattering"}, widgets.OnOff, ()),
      ({"name":"ic_fu_tau"}, widgets.OpenButton, ()),
      ({"name":"ic_scale_gg"}, widgets.FloatSpinner, ()),
      ({"name":"ic_properties"}, widgets.OpenButton, ()),
      ({"name":"ic_set_gg", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
      ({"name":"ic_files"}, widgets.OpenButton, ()),
      ({"name":"ic_fu_reff"}, widgets.OpenButton, ()),
      ({"name":"ic_file"}, widgets.OpenButton, ()),
      ({"name":"ic_cloudcover"}, widgets.FloatSpinner, ()),
      ({"name":"ic_set_tau"}, widgets.FloatSpinner, ()),
      ({"name":"ic_scale_ssa"}, widgets.FloatSpinner, ()),
      ({"name":"ic_properties_interpolate"}, widgets.OnOff, ()),
      ({"name":"ic_layer"}, widgets.OnOff, ()),
      ({"name":"ic_level"}, widgets.OnOff, ()),
      ({"name":"ic_set_tau550"}, widgets.FloatSpinner, ()),
      ({"name":"ic_habit"}, widgets.OpenButton, ()),
#aky17092009      ({"name":"cloud_fraction_map"}, widgets.OpenButton, ()),
#aky17092009      ({"name":"cloud_fraction_file"}, widgets.OpenButton, ()),
#aky17092009      ({"name":"cloud_overlap"}, widgets.OpenButton, ()),
      ),
    ( ("Surface",), 
      ({"name":"albedo", "max_val":1, "min_val":0, "increment":0.01}, widgets.FloatSpinner, ()),
      ({"name":"albedo_file",}, widgets.OpenButton, ()),
      ({"name":"surface_type", "max_val":20, "min_val":0,}, widgets.IntSpinner, ()),
      ({"name":"albedo_library", "choices":["None", "IGBP"]}, widgets.Choice, ()),
      ({"name":"rpv_file",}, widgets.OpenButton, ()),
      ({"name":"rpv_k"   , "max_val":None,    "min_val":None, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"rpv_rho0"   , "max_val":None,    "min_val":None, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"rpv_theta"   , "max_val":None,    "min_val":None, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"rpv_sigma"   , "max_val":None,    "min_val":None, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"rpv_t1"   , "max_val":None,    "min_val":None, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"rpv_t2"   , "max_val":None,    "min_val":None, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"rpv_scale"   , "max_val":None,    "min_val":None, "increment":0.1},  widgets.FloatSpinner, ()),
      ({"name":"rpv_library"}, widgets.OpenButton, ()),
      ({"name":"cox_and_munk_u10_map"}, widgets.OpenButton, ()),
      ({"name":"cox_and_munk_sal"}, widgets.FloatSpinner, ()),
      ({"name":"cox_and_munk_u10"}, widgets.FloatSpinner, ()),
      ({"name":"cox_and_munk_pcl"}, widgets.FloatSpinner, ()),
      ({"name":"cox_and_munk_uphi"}, widgets.FloatSpinner, ()),
      ({"name":"cox_and_munk_solar_wind"}, widgets.OnOff, ()),
      ({"name":"surface_temperature", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
      ({"name":"brdf_ambrals"}, widgets.Text, ()),
      ),
    ( ("Molecular",), 
      ({"name":"o3_crs", "choices":["Bass_and_Paur", "Molina", "Daumont"]}, widgets.Choice, ()),
      ({"name":"rayleigh_crs", "choices":["Bodhaine", "Nicolet", "Penndorf"]}, widgets.Choice, ()),
      ({"name":"no_absorption"  ,} , widgets.OnOff, ()),
      ({"name":"no_molecular_absorption"  , } , widgets.OnOff, ()),
      ({"name":"no_rayleigh"  , } , widgets.OnOff, ()),
      ({"name":"no_scattering"  , } , widgets.OnOff, ()),
      ({"name":"crs_file", "choices":["1", "2"]}, widgets.ListAndFile, ()),
      ({"name":"rayleigh_tau_file"}, widgets.OpenButton, ()),
      ({"name":"molecular_tau_file"}, widgets.OpenButton, ()),
      ({"name":"absorption", "choices":["O4", "N2", "CO", "SO2", "HH3"]}, widgets.ExpandableOnOff, ()),
      ),
    ( ("Solver",), 
      ({"name":"rte_solver", "choices":["disort", "twostr", "sdisort", "disort2", "qdisort", "mystic", "polradtran"]}, widgets.Choice, ()),
      ({"name":"source", "choices":["solar", "thermal" ]}, widgets.Choice, ()),
      ({"name":"nstr", "max_val":None, "min_val":2,}, widgets.IntSpinner, ()),
      ({"name":"deltam", "out_value":"off", "write_value":False}, widgets.OnOff, ()),
      ({"name":"fisot"  ,} , widgets.OnOff, ()),
      ({"name":"polradtran_nstokes"}, widgets.IntSpinner, ()),
      ({"name":"polradtran_max_delta_tau", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
      ({"name":"polradtran_aziorder"}, widgets.IntSpinner, ()),
      ({"name":"polradtran_src_code"}, widgets.IntSpinner, ()),
      ({"name":"polradtran_quad_type"}, widgets.OpenButton, ()),
      ({"name":"nrefrac"}, widgets.IntSpinner, ()),
#aky17092009      ({"name":"no_raman"}, widgets.OnOff, ()),
#aky17092009      ({"name":"raman"}, widgets.OnOff, ()),
      ({"name":"nscat"}, widgets.IntSpinner, ()),
#aky17092009      ({"name":"ichap"}, widgets.IntSpinner, ()),
      ),
    (("Monte Carlo",),
     ({"name":"mc_icloud_file"}, widgets.OpenButton, ()),
#aky17092009     ({"name":"mc_maxscatters"}, widgets.IntSpinner, ()),
     ({"name":"mc_rpv_type"}, widgets.OpenButton, ()),
     ({"name":"mc_escape"}, widgets.OnOff, ()),
     ({"name":"mc_hiddenline"}, widgets.OnOff, ()),
     ({"name":"mc_sensorposition"}, widgets.Text, ()),
     ({"name":"mc_polarisation"}, widgets.OnOff, ()),
#aky17092009     ({"name":"mc_lidar"}, widgets.OpenButton, ()),
     ({"name":"mc_surfaceparallel"}, widgets.OnOff, ()),
     ({"name":"mc_randomseed"}, widgets.IntSpinner, ()),
#aky17092009     ({"name":"mc_delta_scaling", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
     ({"name":"mc_sensordirection"}, widgets.Text, ()),
     ({"name":"mc_ipa"}, widgets.OnOff, ()),
     ({"name":"mc_rpv_file"}, widgets.OpenButton, ()),
     ({"name":"mc_relerr"}, widgets.FloatSpinner, ()),
     ({"name":"mc_ambrals_file"}, widgets.OpenButton, ()),
     ({"name":"mc_truncate", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
     ({"name":"mc_spherical"}, widgets.OnOff, ()),
     ({"name":"mc_photons"}, widgets.IntSpinner, ()),
#aky17092009     ({"name":"mc_clone"}, widgets.OnOff, ()),
     ({"name":"mc_actinic"}, widgets.OnOff, ()),
#aky17092009     ({"name":"mc_jacobian"}, widgets.OnOff, ()),
#aky17092009     ({"name":"mc_radial_pathlength_dt", "min_val":-1.0, "max_val":1.0}, widgets.FloatSpinner, ()),
     ({"name":"mc_readrandomstatus"}, widgets.OnOff, ()),
     ({"name":"mc_surface_reflectalways"}, widgets.OnOff, ()),
#aky17092009     ({"name":"mc_azimuth_old"}, widgets.OnOff, ()),
     ({"name":"mc_std"}, widgets.OnOff, ()),
#aky17092009     ({"name":"mc_escape_ddis"}, widgets.FloatSpinner, ()),
     ({"name":"mc_wcloud_file"}, widgets.OpenButton, ()),
     ({"name":"mc_photons_file"}, widgets.OpenButton, ()),
#aky17092009     ({"name":"mc_momcld_file"}, widgets.OpenButton, ()),
     ({"name":"mc_backward_writeallpixels"}, widgets.OnOff, ()),
     ({"name":"mc_elevation_file"}, widgets.OpenButton, ()),
     ({"name":"mc_albedo_file"}, widgets.OpenButton, ()),
#aky17092009     ({"name":"mc_lidar_abserr"}, widgets.FloatSpinner, ()),
#aky17092009     ({"name":"mc_n_clone_max"}, widgets.FloatSpinner, ()),
     ({"name":"mc_visualize"}, widgets.OnOff, ()),
#aky17092009     ({"name":"mc_pcld_file"}, widgets.OpenButton, ()),
     ({"name":"mc_readrandomseed"}, widgets.OnOff, ()),
     ({"name":"mc_temperature_file"}, widgets.OpenButton, ()),
     ({"name":"mc_basename"}, widgets.OpenButton, ()),
#aky17092009     ({"name":"mc_bcond"}, widgets.OpenButton, ()),
     ({"name":"mc_backward_writeback"}, widgets.OnOff, ()),
#aky17092009     ({"name":"mc_lidar_file"}, widgets.OpenButton, ()),
     ),
    ( ("Output",), 
      ({"name":"heating_rate", "choices":["None", "local", "layer_cd"]}, widgets.Choice, ()),
      ({"name":"brightness"  ,    } , widgets.OnOff, ()),
      ({"name":"reflectivity"  ,  } , widgets.OnOff, ()),
      ({"name":"transmittance"  , } , widgets.OnOff, ()),
      ({"name":"zout"}, widgets.Text, ()),
      ({"name":"umu"}, widgets.Text, ()),
      ({"name":"phi"}, widgets.Text, ()),
      ({"name":"prndis"}, widgets.Text, ()),
#aky17092009      ({"name":"prndis" , "spins":["specify", "specify"],} , widgets.IntSpinner, ()),
#aky17092009      ({"name":"header"}, widgets.OnOff, ()),
#aky17092009      ({"name":"flexstor"}, widgets.OnOff, ()),
      ),
    ( ("Misc",), 
      ({"name":"quiet",}, widgets.OnOff, ()),
      ({"name":"verbose"}, widgets.OnOff, ()),
      ({"name":"data_files_path"}, widgets.OpenButton, ()),
#aky17092009      ({"name":"satellite_geometry"}, widgets.OpenButton, ()),
#aky17092009      ({"name":"raman_delta_wvl"}, widgets.FloatSpinner, ()),
#aky17092009      ({"name":"atm_z_grid"}, widgets.Text, ()),
      ),
    )
#-----------------------------------------------------------------------

if __name__ == "__main__":    
    for obj in create_list:
        print "-" * 42
        print obj[0][0]
        print "-" * 7
        for item in obj[1:]:
            print "\t" + item[0]["name"]
            txt = "\t  "
            l = item[0].keys()
            l.sort()
            for i in l:
                if i == "name": continue
                txt += "'%s'=" % i + str(item[0][i]) + ", "
            if txt != "\t  ": print txt
            print "\t  '%s'" % str(item[1]).split("'")[-2]

