      SUBROUTINE  qdisort( nlyr, dtauc, ssalb, pmom, temper, wvnmlo,
     $     wvnmhi, usrtau, ntau, utau, nstr, usrang, numu, umu, 
     $     nphi, phi, fbeam, beta, nil, umu0, phi0, newgeo, zd, spher, 
     $     radius, fisot, albedo, btemp, ttemp, temis, deltam, planck, 
     $     onlyfl, accur, quiet, ierror, prnt, header,
     $     maxcly, maxulv, maxumu, maxcmu, maxphi, 
     $     rfldir, rfldn, flup, dfdt, uavg, uu, u0u, nsca,
     $     uavgdn, uavgso, uavgup,
     $     nrefrac, ichap, vn,
     $     ndenssza, denssza, denssig, denstab, dtauc_mb, gsrc, qsrc,
     $     qsrcu, guum, iwarn)

C
C+---------------------------------------------------------------------+
C------------------    I/O VARIABLE SPECIFICATIONS     -----------------
C+---------------------------------------------------------------------+
C
      INCLUDE 'DISORT.MXD'

      CHARACTER  HEADER*127
      LOGICAL  DELTAM, newgeo, quiet, planck, onlyfl, PRNT(7), 
     $     SPHER, usrang, USRTAU, gsrc
      INTEGER  ierror(33), MAXCLY, MAXULV, MAXCMU, maxphi, maxumu, 
     $     NLYR, nphi, NSTR, NTAU, numu, ndenssza, iwarn
      REAL*4     accur, ALBEDO, beta(0:maxcly), BTEMP,
     $     DTAUC( MAXCLY ), FBEAM, FISOT, phi0, 
     $     PHI( MAXPHI ), PMOM( 0:MAXCMU, MAXCLY ), RADIUS,
     $     SSALB( MAXCLY ), TEMPER( 0:MAXCLY ), TEMIS, TTEMP,
     $     WVNMLO, WVNMHI, UMU0, UTAU( MAXULV ), 
     $     U0U(MAXUMU, MAXULV), UU( MAXUMU, MAXULV, MAXPHI ),
     $     ZD( 0:MAXCLY ), VN(0:MAXCLY), DTAUC_mb( MAXCLY ),
     $     guum( MAXUMU, MAXULV, 0:MAXCMU-1 )
C     
      REAL*4     RFLDIR( MAXULV ), RFLDN( MAXULV ),
     $     FLUP( MAXULV ),
     $     UAVG( MAXULV ), DFDT( MAXULV ), umu( maxumu ),
     $     UAVGDN( MAXULV ), UAVGUP( MAXULV ), UAVGSO( MAXULV )
      REAL*4 qsrc ( MAXCMU, 0:maxulv-1, MAXCMU )
      REAL*4 qsrcu( MAXUMU, 0:maxulv-1, MAXCMU )
*
      LOGICAL noplnk
      REAL*8     dpaccur, dpALBEDO, dpbeta(0:mxcly), dpBTEMP,
     $     dpDTAUC( MXCLY ), dpFBEAM, dpFISOT, dpphi0, 
     $     dpPHI( MXPHI ), dpPMOM( 0:MXCMU, MXCLY ), dpRADIUS,
     $     dpSSALB( MXCLY ), dpTEMPER( 0:MXCLY ), dpTEMIS, dpTTEMP,
     $     dpWVNMLO, dpWVNMHI, dpUMU0, dpUTAU( MXULV ), 
     $     dpU0U(MXUMU, MXULV), dpUU( MXUMU, MXULV, MXPHI ),
     $     dpZD( 0:MXCLY ), dpVN(0:MXCLY), dpDTAUC_mb( MXCLY ),
     $     dpgUUM( MXUMU, MXULV, 0:MXCMU-1 )
C     
      REAL*8     dpRFLDIR( MXULV ), dpRFLDN( MXULV ),
     $     dpFLUP( MXULV ),
     $     dpUAVG( MXULV ), dpDFDT( MXULV ), dpumu( mxumu ),
     $     dpUAVGDN( MXULV ), dpUAVGUP( MXULV ), dpUAVGSO( MXULV )
*
      REAL*8 dpqsrc( MXCMU, 0:2*MXCLY, MXCMU )
      REAL*8 dpqsrcu( MXUMU, 0:2*MXCLY, MXCMU )
*
      INTEGER nrefrac, nsca, ichap, nil
*
      INTEGER lc, lu, iq, j, iu
      LOGICAL prtinp, prtout, debug

*--------------------------------------------------------
*     Variables that will be eventually input to sdisort
*
      REAL*4 denssza(*), denssig(*), denstab(0:maxcly,*)
      REAL*8 dpdenssza(MXSZA), dpdenssig(0:mxcly), 
     $     dpdenstab(mxsza,0:mxcly)
*
      INTEGER brosza
*

      prtinp=.FALSE.
      prtout=.FALSE.
*         prtinp=.TRUE.
*         prtout=.TRUE.
      debug =.FALSE.
      if (prnt(1) .AND. prnt(7) ) then
         prnt(1) = .TRUE.
         prnt(7) = .TRUE.
caky         debug  = .TRUE.
caky         prtinp=.TRUE.
caky         prtout=.TRUE.
      endif
*
*     First check that the arys are large enough
*
      IF( MXSZA.LT.ndenssza ) THEN
         write (0,*) '* Error, too many solar zenith angles in denssza.' 
         write (0,*) '* Increase MXSZA in libsrc_f/dpsdisort.f to at'
         write (0,*) '* least',ndenssza,' and recompile libRadtran!'
         RETURN
      ENDIF
*
* For input convert between REAL*4 (uvspec working environment) 
* and REAL*8 for double precision sdisort
*

      noplnk     = .NOT. planck
      dpaccur    = dble(accur)
      dpalbedo   = dble(albedo)
      dpbtemp    = dble(btemp)
      dpfbeam    = dble(fbeam)
      dpfisot    = dble(fisot)
      dpphi0     = dble(phi0)
      dpradius   = dble(radius)
      dptemis    = dble(temis)
      dpttemp    = dble(ttemp)
      dpwvnmlo   = dble(wvnmlo)
      dpwvnmhi   = dble(wvnmhi)
      dpumu0     = dble(umu0)

* brosza = 0: density is a function of altitude, that is a profile
* brosza = 1: density is a function of altitude and sza, that is a matrix

      brosza = 0 ! This is the default

      IF ( ndenssza .GT. 0 ) THEN
         brosza = 1
         DO j = 1, ndenssza
            dpdenssza(j) = dble(denssza(j))
         ENDDO
         DO lc = 1, maxcly
            dpdenssig(lc) = dble(denssig(lc))
         ENDDO
         DO j = 1, ndenssza
            DO lc = 0, maxcly
               dpdenstab(j,lc) = dble(denstab(lc,j))
            ENDDO
         ENDDO
         IF ( prtinp ) THEN
*            DO j = 1, ndenssza
            DO j = 1, mxsza
               WRITE(*,*) "qdisort denssza", j, dpdenssza(j)
            ENDDO
*            DO lc = 1, maxcly
            DO lc = 0, mxcly
               WRITE(*,*)"qdisort denssig", lc, dpdenssig(lc)
            ENDDO
*            DO j = 1, ndenssza
            DO j = 1, mxsza
               DO lc = 0, maxcly
                  WRITE(*,*)"qdisort denstab", lc, dpdenstab(lc,j)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      DO j = 1, maxphi
         dpphi(j) = dble(phi(j))
      ENDDO
      IF ( prtinp ) THEN
         WRITE(*,*) "qdisort nlyr", nlyr, ntau, numu, nphi, nil
         WRITE(*,*) "qdisort wvnmlo", wvnmlo, wvnmhi
         WRITE(*,*) "qdisort logicals", usrtau, usrang, newgeo, 
     $        planck, deltam, onlyfl, spher, quiet
         WRITE(*,*) "qdisort maxs", maxcly, maxulv, maxumu, maxcmu, 
     $        maxphi
         WRITE(*,*) "qdisort fbeam", fbeam, umu0, phi0, radius,
     $        fisot
         WRITE(*,*) "qdisort albedo", albedo, btemp, ttemp, temis,
     $        accur
         WRITE(*,*) "qdisort ns", nsca, nrefrac, ichap, ndenssza
         DO j = 1, mxphi
*         DO j = 1, maxphi
            WRITE(*,*) "qdisort phi", j, dpphi(j)
         ENDDO
      ENDIF

      DO lc = 1, maxcly
         dpdtauc(lc)       = dble(dtauc(lc))
         dpdtauc_mb(lc)    = dble(dtauc_mb(lc))
         dpssalb(lc)       = dble(ssalb(lc))        
         DO iq = 0, maxcmu
            dppmom(iq,lc) = dble(pmom(iq,lc))
         ENDDO
      ENDDO
      DO lc = 0, maxcly
         dptemper(lc)   = dble(temper(lc))
         dpzd(lc)       = dble(zd(lc))    
         dpVN(lc)       = dble(vn(lc))
      ENDDO
      DO lu = 1, maxulv
         dputau(lu)     = dble(utau(lu))
      ENDDO
      DO iu = 1, maxumu
         dpumu(iu)      = dble(umu(iu))
      ENDDO
      IF ( prtinp ) THEN
*         DO lc = 1, maxcly
         DO lc = 1, mxcly
            WRITE(*,*)"qdisort dtauc", lc, dpdtauc(lc),dpdtauc_mb(lc),
     $           dpssalb(lc)
*     DO iq = 0, maxcmu
            DO iq = 0, mxcmu
               WRITE(*,*)"qdisort pmom", lc, iq, dppmom(iq,lc)
            ENDDO
         ENDDO
*         DO lc = 0, maxcly
         DO lc = 0, mxcly
            WRITE(*,*)"qdisort dtemper", lc, dptemper(lc), dpzd(lc),
     $           dpVN(lc)
         ENDDO
*         DO lu = 1, maxulv
caky         DO lu = 1, mxulv
caky            WRITE(*,*)"qdisort dputau", lu, dputau(lu)
caky         ENDDO
*         DO iu = 1, maxumu
caky         DO iu = 1, mxumu
caky            WRITE(*,*)"qdisort umu", iu, dpumu(iu)
caky         ENDDO
      ENDIF
*
*     Set general source
*     
      IF ( gsrc ) THEN
         DO iq = 1, maxcmu
            DO lc = 0, maxulv-1
               DO j = 1, maxcmu
                  dpqsrc(iq,lc,j) = dble(qsrc(iq,lc,j))
               ENDDO
            ENDDO
         ENDDO
caky         DO iq = 1, maxcmu
caky            DO lc = 0, 2*maxcly
caky               DO j = 1, 1
caky                  write(*,*)"Wqsrc", iq, lc, j, qsrc(iq,lc,j)
caky               ENDDO
caky            ENDDO
caky         ENDDO         
         IF ( usrang ) THEN
            DO iu = 1, maxumu
            DO lc = 0, maxulv-1
                  DO j = 1, maxcmu
                     dpqsrcu(iu,lc,j) = dble(qsrcu(iu,lc,j))
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
         IF ( prtinp ) THEN
*            DO iq = 1, maxcmu
            DO iq = 1, mxcmu
*               DO lc = 0, maxcly
               DO lc = 0, 2*mxcly
*                  DO j = 1, maxcmu
                  DO j = 1, mxcmu
                     WRITE(*,*) "qdisort qsrc", iq, lc, j, 
     $                    dpqsrc(iq,lc,j)
                  ENDDO
               ENDDO
            ENDDO
            IF ( usrang .and. prnt(1) .and. prnt(6)) THEN
               DO iu = 1, mxcmu
*     DO lc = 0, maxcly
                  DO lc = 0, 2*mxcly
*     DO j = 1, maxcmu
                     DO j = 1, mxcmu
                        WRITE(*,*) "qdisort qsrcu", iu, lc, j, 
     $                       dpqsrc(iu,lc,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
      ENDIF

      noplnk = .true.
      dpbtemp = 0.0
      dpttemp = 0.0

      CALL  dpqdisort
     $     ( ICHAP, nlyr, dpdtauc, dpssalb, dppmom, dptemper, dpwvnmlo,
     $     dpwvnmhi, usrtau, ntau, dputau, nstr, usrang, numu, dpumu, 
     $     nphi, dpphi, dpfbeam, dpbeta, nil, dpumu0, dpphi0, newgeo, 
     $     dpzd, spher, dpradius, dpfisot, 
     $     dpalbedo, dpbtemp, dpttemp, dptemis, deltam, noplnk, 
     $     onlyfl, dpaccur, quiet, ierror, prnt, header,
     $     mxcly, mxulv, mxumu, mxcmu, mxphi, 
     $     dprfldir, dprfldn, dpflup, dpdfdt, dpuavg, dpuu, dpu0u, nsca,
     $     brosza, dpdtauc_mb, dpdenssig, dpdenstab, dpdenssza,
     $     ndenssza, dpVN, nrefrac, dpuavgdn, dpuavgso, dpuavgup, 
     $     dpqsrc, dpqsrcu, gsrc, dpguum, debug, iwarn)


*
* For output convert between REAL*4 (uvspec working environment) 
* and REAL*8 for double precision sdisort
*

      DO lu = 1, maxulv
         rfldir(lu)   = real(dprfldir(lu))
         rfldn(lu)    = real(dprfldn(lu))
         flup(lu)     = real(dpflup(lu))
         uavg(lu)     = real(dpuavg(lu))
         uavgso(lu)   = real(dpuavgso(lu))
         uavgup(lu)   = real(dpuavgup(lu))
         uavgdn(lu)   = real(dpuavgdn(lu))
         DO iu = 1, maxumu
            u0u(iu,lu) = real(dpu0u(iu,lu))
            DO j = 1, maxphi
               uu(iu,lu, j) = real(dpuu(iu,lu,j))
            ENDDO
         ENDDO         
         DO iu = 1, maxumu
            DO j = 0, maxcmu-1
               guum(iu,lu, j) = real(dpguum(iu,lu,j))
            ENDDO
         ENDDO
      ENDDO
      IF ( prtout ) THEN
         DO lu = 1, maxulv

            WRITE(*,*) "qdisort rfldir", lu, rfldir(lu), rfldn(lu),
     $           flup(lu),
     $           uavg(lu), uavgso(lu), uavgup(lu), uavgdn(lu)
         ENDDO
caky         DO lu = 1, maxulv
caky            DO iu = 1, maxumu
caky               WRITE(*,*)"qdisort u0u", lu, iu, u0u(iu,lu)
caky               DO j = 1, maxphi
caky                  WRITE(*,*)"qdisort uu", lu, iu, uu(iu,lu,j)
caky               ENDDO
caky            ENDDO         
caky         ENDDO         
      ENDIF

      RETURN
      END


      SUBROUTINE  dpqdisort
     $     ( ICHAP, nlyr, dtauc, ssalb, pmom, temper, wvnmlo,
     $     wvnmhi, usrtau, ntau, utau, nstr, usrang, numu, umu, 
     $     nphi, phi, fbeam, beta, nil, umu0, phi0, newgeo, zd, spher, 
     $     radius, fisot, albedo, btemp, ttemp, temis, deltam, noplnk, 
     $     onlyfl, accur, quiet, ierror, prnt, header,
     $     maxcly, maxulv, maxumu, maxcmu, maxphi, 
     $     rfldir, rfldn, flup, dfdt, uavg, uu, u0u, nsca,
     $     brosza, dtauc_mb, sigbro, DENSBRO, SZA_BRO,
     $     ndenssza, VN, nrefrac, uavgdn, uavgso, uavgup, 
     $     qsrc, qsrcu, gsrc, guum, debug, iwarn )
     
*+-----------------------------------------------------------------------+
* Copyright (C) 1992, 94, 95 Arve Kylling
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 1, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* To obtain a copy of the GNU General Public License write to the
* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
* USA.
*
*+-----------------------------------------------------------------------+
***********************************************************************
*
*     Strongly modified version of disort, this version solves the
*     radiative transfer equation in pseudo-spherical or spherical 
*     geometry. The main changes are:
*
*     1) The medium may be taken to be pseudo-spherical (spher=.true.
*        and nil=0) or spherical (spher=.true. and nil.gt.0). 
*
*     2) Only lambertian surface is allowed
*
*     3) The present implementation of sdisort.f does not work for 
*        thermal radiation. This is not a problem for UVspec, but 
*        may be of concern for those who want to use sdisort.f some 
*        other place.
*
*     If run in spherical geometry the code should be compiled and
*     linked in double precision. I have not tried the spherical
*     version in single precision and do not know if it does what it
*     should do. If you wonder how to build a double precision version
*     of this routine, see the file Makefile_double that comes with the
*     uvspec distribution.
*
*    ( See disort.doc and twostr.doc for further documentation )
*
*     Bug reports and other feedback to arve@kaja.gi.alaska.edu
*
************************************************************************
C
C+---------------------------------------------------------------------+
C------------------    I/O VARIABLE SPECIFICATIONS     -----------------
C+---------------------------------------------------------------------+
C
      implicit double precision (A-H,O-Z)
      INTEGER MXCLY, MXULV, MXCMU, MXUMU, MXPHI,
     $        MI, MI9M2, NNLYRI 
      INCLUDE 'DISORT.MXD'
      INTEGER brosza
      INTEGER iwarn
      CHARACTER  HEADER*127
      LOGICAL  DELTAM, newgeo, quiet, NOPLNK, onlyfl, PRNT(7), 
     $     SPHER, usrang, USRTAU, gsrc
      INTEGER  ierror(33), MAXCLY, MAXULV, MAXCMU, maxphi, maxumu, 
     $     NLYR, nphi, NSTR, NTAU, numu
      real*8    accur, ALBEDO, beta(0:maxcly), BTEMP,
     $     DTAUC( MAXCLY ), FBEAM, FISOT, phi0, 
     $     PHI( MAXPHI ), PMOM( 0:MAXCMU, MAXCLY ), RADIUS,
     $     SSALB( MAXCLY ), TEMPER( 0:MAXCLY ), TEMIS, TTEMP,
     $     WVNMLO, WVNMHI, UMU0, UTAU( MAXULV ), 
     $     U0U(MAXUMU, MAXULV), UU( MAXUMU, MAXULV, MAXPHI ),
     $     ZD( 0:MAXCLY ), DTAUC_MB(MAXCLY), SIGBRO(0:*), 
     $     DENSBRO(mxsza,0:*), VN(0:MAXCLY), 
     $     qsrc( MAXCMU, 0:2*MAXCLY, MAXCMU ),
     $     qsrcu( MAXUMU, 0:2*MAXCLY, MAXCMU ),
     $     guum( MAXUMU, MAXULV, 0:MAXCMU-1 )
C     
      real*8     RFLDIR( MAXULV ), 
     $           RFLDN( MAXULV ),  
     $           FLUP( MAXULV ),
     $     UAVG( MAXULV ), DFDT( MAXULV ), umu( maxumu ),
     $     UAVGDN( MAXULV ), UAVGUP( MAXULV ), UAVGSO( MAXULV )
      integer nil
      LOGICAL debug
C
C+---------------------------------------------------------------------+
C      ROUTINES CALLED (IN ORDER):  SLFTST, ZEROAL, schekin, ssetdis,
C                                   sprtinp, slepoly, ssoleig, SETBCO,
C                                   supbeam, SETPCO, supisot, sterpev,
C                                   sterpso, ssetmtx, ssolve0, sfluxes,
*                                   susrint
C+---------------------------------------------------------------------+
C
C  INDEX CONVENTIONS (FOR ALL DO-LOOPS AND ALL VARIABLE DESCRIPTIONS):
*
*     il     :  For iteration over the perturbation source.
C
C  IQ,JQ,KQ  :  FOR COMPUTATIONAL POLAR ANGLES ('QUADRATURE ANGLES')
C
C   IQ/2     :  FOR HALF THE COMPUTATIONAL POLAR ANGLES (JUST THE ONES
C               IN EITHER 0-90 DEGREES, OR 90-180 DEGREES)
C
C     K,L    :  FOR LEGENDRE EXPANSION COEFFICIENTS OR, ALTERNATIVELY,
C               SUBSCRIPTS OF ASSOCIATED LEGENDRE POLYNOMIALS
C
C     LU     :  FOR USER LEVELS
C
C     LC     :  FOR COMPUTATIONAL LAYERS (EACH HAVING A DIFFERENT
C               SINGLE-SCATTER ALBEDO AND/OR PHASE FUNCTION)
C
C    LEV     :  FOR COMPUTATIONAL LEVELS
C
C+---------------------------------------------------------------------+
C               I N T E R N A L    V A R I A B L E S
C
C   AMB(IQ/2,IQ/2)    FIRST MATRIX FACTOR IN REDUCED EIGENVALUE PROBLEM
C                     OF EQS. SS(12), STWJ(8E)  (USED ONLY IN 'ssoleig')
C
C   APB(IQ/2,IQ/2)    SECOND MATRIX FACTOR IN REDUCED EIGENVALUE PROBLEM
C                     OF EQS. SS(12), STWJ(8E)  (USED ONLY IN 'ssoleig')
C
C   ARRAY(IQ,IQ)      SCRATCH MATRIX FOR 'ssoleig', 'supbeam' AND 'supisot'
C                     (SEE EACH SUBROUTINE FOR DEFINITION)
C
C   B()               RIGHT-HAND SIDE VECTOR OF EQ. SC(5) GOING INTO
C                     *ssolve0*;  RETURNS AS SOLUTION VECTOR
C                     VECTOR CAPITAL-L, THE CONSTANTS OF INTEGsratioN
C
C   BDR(IQ/2,0:IQ/2)  BOTTOM-BOUNDARY BIDIRECTIONAL REFLECTIVITY FOR A
C                     GIVEN AZIMUTHAL COMPONENT.  FIRST INDEX ALWAYS
C                     REFERS TO A COMPUTATIONAL ANGLE.  SECOND INDEX:
C                     IF ZERO, REFERS TO INCIDENT BEAM ANGLE -UMU0-;
C                     IF NON-ZERO, REFERS TO A COMPUTATIONAL ANGLE.
C
C   BPLANK            INTENSITY EMITTED FROM BOTTOM BOUNDARY
C
C   CBAND()           MATRIX OF LEFT-HAND SIDE OF THE LINEAR SYSTEM
C                     EQ. SC(5), SCALED BY EQ. SC(12);  IN BANDED
C                     FORM REQUIRED BY LINPACK SOLUTION ROUTINES
C
C   CC(IQ,IQ)         CAPITAL-C-SUB-IJ IN EQ. SS(5)
C
C   CH(LC)            THE CHAPMAN-FACTOR TO CORRECT FOR PSEUDO-
C                     SPHERICAL GEOMETRY IN THE DIRECT BEAM.
C
C   CMU(IQ)           COMPUTATIONAL POLAR ANGLES (GAUSSIAN)
C
C   CWT(IQ)           QUADRATURE WEIGHTS CORRESP. TO -CMU-
C
C   DELM0             KRONECKER DELTA, DELTA-SUB-M0, WHERE 'M' = MAZ
C                     IS THE NUMBER OF THE FOURIER COMPONENT IN THE
C                     AZIMUTH COSINE EXPANSION
C
C   EVAL(IQ)          TEMPORARY STORAGE FOR EIGENVALUES OF EQ. SS(12)
C
C   EVECC(IQ,IQ)      COMPLETE EIGENVECTORS OF SS(7) ON RETURN FROM
C                     *ssoleig* ; STORED PERMANENTLY IN -GC-
C
C   EXPBEA(LC)        TRANSMISSION OF DIRECT BEAM IN DELTA-M OPTICAL
C                     DEPTH COORDINATES
C
C   FLDN(LU)          DIFFUSE DOWN FLUX (DELTA-M SCALED)
C
C   FLDIR(LU)         DIRECT BEAM FLUX (DELTA-M SCALED)
C
C   FLYR(LC)          TRUNCATED FRACTION IN DELTA-M METHOD
C
C   GL(K,LC)          PHASE FUNCTION LEGENDRE POLY. EXPANSION
C                     COEFFICIENTS, CALCULATED FROM 'PMOM' BY
C                     INCLUDING SINGLE-SCATTERING ALBEDO, FACTOR
C                     2K+1, AND (IF DELTAM=TRUE) THE DELTA-M
C                     SCALING
C
C   GC(IQ,IQ,LC)      EIGENVECTORS AT POLAR QUADRATURE ANGLES,
C                     LITTLD-G  IN EQ. SC(1)
C
*   gl(iu,iq,lc)      Eigenvectors interpolated to user polar angles
*                     ( littlD-g in Eqs. SC(3) and S1(8-9), i.e.
*                     capital-G without the capital-L factor )
*
C   IPVT(LC*IQ)       INTEGER VECTOR OF PIVOT INDICES FOR LINPACK
C                     ROUTINES
C
C   KK(IQ,LC)         EIGENVALUES OF COEFF. MATRIX IN EQ. SS(7)
C
C   LAYRU(LU)         COMPUTATIONAL LAYER IN WHICH USER OUTPUT LEVEL
C                     -UTAU(LU)- IS LOCATED
C
C   LL(IQ,LC)         CONSTANTS OF INTEGsratioN CAPITAL-L IN EQ. SC(1),
C                     OBTAINED BY SOLVING SCALED VERSION OF EQ. SC(5)
C
C   LYRCUT            TRUE, RADIATION IS ASSUMED ZERO BELOW LAYER
C                     -NCUT- BECAUSE OF ALMOST COMPLETE ABSORPTION
C
C   NCUT              COMPUTATIONAL LAYER NUMBER IN WHICH ABSORPTION
C                     OPTICAL DEPTH FIRST EXCEEDS -ABSCUT-
C
C   OPRIM(LC)         SINGLE SCATTERING ALBEDO AFTER DELTA-M SCALING
C
C   PASS1             TRUE ON FIRST ENTRY, FALSE THEREAFTER
C
C   PKAG(0:LC)        INTEGRATED PLANCK FUNCTION FOR INTERNAL EMISSION
C                     AT LAYER BOUNDARIES
C
C   PKAGC(LC)         INTEGRATED PLANCK FUNCTION FOR INTERNAL EMISSION
C                     AT LAYER CENTER
C
*   psi0(iq),         Sum just after square bracket in Eq. SD(9), for
*    psi1(iq)         z0 and z1 (thermal source) respectively  (zbs0
*                     and zbs1 for beam source)
*
C   TAUC(0:LC)        CUMULATIVE OPTICAL DEPTH (UN-DELTA-M-SCALED)
C
C   TAUCPR(0:LC)      CUMULATIVE OPTICAL DEPTH (DELTA-M-SCALED IF
C                     DELTAM = TRUE, OTHERWISE EQUAL TO -TAUC-)
C
C   TPLANK            INTENSITY EMITTED FROM TOP BOUNDARY
C
C   U0C(IQ,LU)        AZIMUTHALLY-AVERAGED INTENSITY
C
C   UTAUPR(LU)        OPTICAL DEPTHS OF USER OUTPUT LEVELS IN DELTA-M
C                     COORDINATES;  EQUAL TO  -UTAU(LU)- IF NO DELTA-M
C
C   WK()              SCRATCH ARRAY
C
C   xb0(IQ,LC)        X-SUB-ZERO COEFFICIENT IN EQ. KS(4) FOR PSEUDO-
C                     SPHERICAL BEAM SOURCE KS(15).
C
C   xb1(IQ,LC)        X-SUB-ONE COEFFICIENT IN EQ. KS(4) FOR PSEUDO-
C                     SPHERICAL BEAM SOURCE KS(15).
C
C   xba(LC)           ALFA COEFFICIENT IN EQ. KS(4) FOR PSEUDO-
C                     SPHERICAL BEAM SOURCE KS(15).
C
C   XR0(LC)           X-SUB-ZERO IN EXPANSION OF THERMAL SOURCE FUNC-
C                     TION; SEE EQS. KS(4) (HAS NO (MU) DEPENDENCE)
C
C   XR1(LC)           X-SUB-ONE IN EXPANSION OF THERMAL SOURCE FUNC-
C                     TION; SEE EQ. KS(4) (HAS NO (MU) DEPENDENCE)
C
C   XRA(LC)           ALFA IN EXPONENT IN EXPANSION OF THERMAL SOURCE 
C                     FUNCTION; SEE EQ. KS(4) (HAS NO (MU) DEPENDENCE)
C
C   YLM0(L)           NORMALIZED ASSOCIATED LEGENDRE POLYNOMIAL
C                     OF SUBSCRIPT 'L' AT THE BEAM ANGLE (NOT SAVED
C                     AS FUNCTION OF SUPERSCIPT 'M')
C
C   YLMC(L,IQ)        NORMALIZED ASSOCIATED LEGENDRE POLYNOMIAL
C                     OF SUBSCRIPT 'L' AT THE COMPUTATIONAL ANGLES
C                     (NOT SAVED AS FUNCTION OF SUPERSCIPT 'M')
C
*   ylmu(l,iq)        Normalized associated legendre polynomial
*                     of subscript 'l' at the user angles
*                     (NOT saved as function of superscipt 'm')
*
C   Z()               SCRATCH ARRAY USED IN * ssolve0* TO SOLVE A
C                     LINEAR SYSTEM FOR THE CONSTANTS OF INTEGsratioN
C
C   Z0(IQ)            SOLUTION VECTORS Z-SUB-ZERO OF EQ. KS(7-8),
C                     THERMAL RADIATION
C
C   Z1(IQ)            SOLUTION VECTORS Z-SUB-ONE  OF EQ. KS(7-8),
C                     THERMAL RADIATION
C
C   ZA                ALFA COEFFICIENT IN EQ. KS(4), THERMAL SOURCE
*
*   zbau(iu,lc)       zbsa interpolated to user angles 
*
*   zb0u(iu,lc)       zbs0 interpolated to user angles 
*
*   zb1u(iu,lc)       zbs1 interpolated to user angles 
*
*   zpau(iu,lc)       zpsa interpolated to user angles 
*
*   zp0u(iu,lc)       zps0 interpolated to user angles 
*
*   zp1u(iu,lc)       zps1 interpolated to user angles 
C
C   ZBEAMA(LC)        PERMANENT STORAGE FOR THE ALFA COEFFICIENT IN 
C                     EQ. KS(6) FOR PSEUDO-SPHERICAL BEAM SOURCE.
C
C   ZBEAM0(IQ,LC)     PERMANENT STORAGE FOR THE Y-SUB-ZERO COEFFICIENT 
C                     IN EQ. KS(6) FOR PSEUDO-SPHERICAL BEAM SOURCE 
C                     KS(15). OBTAINED BY SOLVING EQS. KS(7-8)
C
C   ZBEAM1(IQ,LC)     PERMANENT STORAGE FOR THE Y-SUB-ONE COEFFICIENT 
C                     IN EQ. KS(6) FOR PSEUDO-SPHERICAL BEAM SOURCE 
C                     KS(15). FOUND BY SOLVING EQS. KS(7-8)
C
C   ZBS0(IQ)          SOLUTION VECTORS Y-SUB-ZERO OF KS(7-8)
C
C   ZBS1(IQ)          SOLUTION VECTORS Y-SUB-ONE OF KS(7-8)
*
*   zbsa(iq)          Alfa coefficient corresponding to zbs0 and zbs1
C
C   ZJ(IQ)            RIGHT-HAND SIDE VECTOR CAPITAL-X-SUB-ZERO IN
C                     EQ. STWJ(6D)
C
C   ZPLK0(IQ,LC)      PERMANENT STORAGE FOR THE THERMAL SOURCE
C                     VECTORS  -Z0-  OBTAINED BY SOLVING  EQ. KS(7-8)
C
C   ZPLK1(IQ,LC)      PERMANENT STORAGE FOR THE THERMAL SOURCE
C                     VECTORS  -Z1-  OBTAINED BY SOLVING  EQ. KS(7-8)
C
C   ZPLKA(LC)         PERMANENT STORAGE FOR THE THERMAL SOURCE
C                     COEFFICIENT -ZA-; ALFA IN EQ. KS(7-8)
C
C+---------------------------------------------------------------------+
C   LOCAL SYMBOLIC DIMENSIONS:
C
C       MXCLY  = Max no. of computational layers
C       MXULV  = Max no. of output levels
C       MXCMU  = Max no. of computation polar angles
C       MXUMU  = Max no. of output polar angles
c       MXPHI  = Max no. of output azimuthal angles
C+---------------------------------------------------------------------+
      PARAMETER ( MI = MXCMU/2, MI9M2 = 9*MI-2,
     $     NNLYRI = MXCMU*MXCLY )

*
      DOUBLE PRECISION d1mach
      real*8 dpsratio
      LOGICAL LYRCUT
      INTEGER layru( mxulv )
      real*8 acmu(mxcmu), azerr, azterm, bdr( mi,0:mi ),
     $     bplank, ch( mxcly ), chtau( 0:2*mxcly+1 ),
     $     cosphi, cmu( mxcmu ), cwt( mxcmu ), delm0, cwt0(mxcmu),
     $     deltamu, epsil,expbea( 0:mxcly ),
     $     flyr( mxcly ), fldn( mxulv ), 
     $     fldir( mxulv ), gl( 0:mxcmu,mxcly ), oprim( mxcly ), 
     $     PHIRAD( MXPHI ), pi, pkag( 0:mxcly ), pkagc(mxcly), rpd, 
     $     tauc( 0:mxcly ), taucpr( 0:mxcly ), tplank,
     $     u0uls(mxumu, mxulv), uum( mxumu, mxulv, 0:mxcmu), 
     $     utaupr( mxulv ),sza_bro(mxsza)
*
*     Variables for the internal source at computational angles
*
      INTEGER ntau_c, numu_c, layru_c( mxulv )
      real*8  utau_c(mxcly+1),
     $     umu_c( 2*mxcmu ),  utaupr_c( mxulv )
*
*     Variables for the internal source at user angles
*
      INTEGER numu_u
      real*8  umu_u( 2*mxcmu )
*
      DATA  nerr / 33 /
*
C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     bro density is a function of SZA => no delta-m method,
C                                         so  that dtaucpr=dtauc
      if (brosza.eq.1) then
        deltam=.false.
      endif
      
C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!      
      
      pi = 2.D0* DASIN(1.0D0)
    
      epsil = 10.D0*d1mach(4)

      
      rpd = pi / 180.D0
*
*aky      IF ( PRNT(1) )  WRITE( *,1010 )  HEADER
*
*     Zero some arrays (not strictly necessary, but otherwise unused
*     parts of arrays collect garbage)
*
      DO i = 1, nerr
         ierror(i) = 0
      ENDDO
      CALL  dpszeroit( CH,   MXCLY )
      CALL  dpszeroit( CMU,  MXCMU )
      CALL  dpszeroit( CWT,  MXCMU )
      CALL  dpszeroit( CWT0, MXCMU )
*     
*     Calculate cumulative optical depth and dither SINGLE-scatter
*     albedo to improve numerical behavior of eigenvalue/vector
*     computation
*

    
      TAUC( 0 ) = 0.D0
      CALL  dpszeroit( TAUC(0), MXCLY+1 )
      DO 20  LC = 1, NLYR
*
*aky 27.11.2008 Added factor of 10 because otherwise I got nan on my MacOX
*
         IF( SSALB(LC) .GT. 1.0-epsil )  SSALB(LC) = 1.D0 - 10.*epsil
         TAUC(LC) = TAUC(LC-1) + DTAUC(LC)
 20   CONTINUE
*
*     Check input dimensions and variables
*
     	 
      CALL  dpschekin( nlyr, dtauc, ssalb, pmom, temper, wvnmlo,
     $     wvnmhi, usrtau, ntau, utau, nstr, usrang, numu, 
     $     umu, fbeam, umu0, spher, fisot, albedo, btemp, ttemp, 
     $     temis, noplnk, onlyfl, ierror, quiet,
     $     maxcly, maxulv, maxumu, maxcmu, 
     $     mxcly, mxulv,  mxcmu, mxumu, tauc, zd )
*
      iret = 0
      DO ierr = 1, nerr
         IF ( ierror(ierr) .NE. 0 ) THEN
            iret = 1  
            WRITE(*,'(/,A,I4,/)')  "SDISORT REPORTS FATAL ERROR: ",
     $           ierr
         ENDIF
      ENDDO
       	
      IF ( iret .EQ. 1 ) RETURN
*
*     Perform various setup operations
*
      
      CALL  dpqsetdis
     $  (ICHAP, acmu, albedo, bdr, beta, bplank,btemp,ch,chtau, 
     $     cmu, cwt, deltam, deltamu, dtauc,EXPbea, fbeam, 
     $     flyr, gl, gsrc, layru, layru_c, lyrcut, maxumu, maxcmu,
     $     ncut, newgeo, 
     $     nlyr, ntau, ntau_c, nn, nstr, noplnk, numu, onlyfl,
     $     oprim, pkag, pkagc, pmom, radius, spher, ssalb, tauc,
     $     taucpr,temis, temper, tplank, ttemp, utau, utau_c,
     $     utaupr, utaupr_c, umu0, umu, usrtau, usrang,
     $     wvnmlo, wvnmhi, 
     $     zd, numu_c, umu_c, numu_u, umu_u, BROSZA,SIGBRO,DENSBRO,
     $     dtauc_mb, sza_bro, ndenssza, VN, nrefrac)
          
*
*     Print input information
*     
      IF ( prnt(1) ) THEN
         write(*,'(A)') 'Layer  Chapman'
         write(*,'(A)') 'number function'
         DO lc = 1, nlyr
            write(*,'(I4,4x,F10.5)') lc, ch(lc)
         ENDDO
      ENDIF

      IF ( prnt(1) ) THEN
            IF (nsca .EQ. 1) THEN
               WRITE(*,*) "Running sdisort in single scattering mode"
            ELSE IF (nsca .EQ. 2) THEN
               WRITE(*,*) "Running sdisort in multiple scattering mode"
            ENDIF
            CALL dpqprtinp( nlyr, dtauc, ssalb, pmom, temper, wvnmlo,
     $           wvnmhi, ntau, utau, nstr, numu, umu, fbeam, umu0,
     $           spher,nil, fisot, albedo, btemp, ttemp, temis, deltam,
     $           noplnk, onlyfl, flyr, lyrcut, oprim, tauc, taucpr, 
     $           maxcmu, gsrc, prnt(7) )
         ENDIF
C     
C ========  BEGIN LOOP TO SUM AZIMUTHAL COMPONENTS OF INTENSITY  =======
C ========  (EQ STWJ 5)
C
      KCONV = 0
      NAZ = NSTR-1
*         
*     General source is used for Raman scattering which is non-zero for three
*     first azimutm terms only.
*      
      IF ( gsrc ) THEN
         NAZ = 2
      ENDIF         
*
*                                            ** AZIMUTH-INDEPENDENT CASE
*
      IF (FBEAM.EQ.0.0 .OR. (1.D0-UMU0).LT.1.D-5 .OR. ONLYFL.OR.
     $     (NUMU.EQ.1.AND.(1.-UMU(1)).LT.1.D-5 ) ) THEN
          NAZ = 0
          IF ( GSRC  ) THEN 
*aky             NAZ = NSTR-1
*         
*     General source is used for Raman scattering which is non-zero for three
*     first azimutm terms only.
*      
             IF ( (NUMU.EQ.1.AND.(1.-UMU(1)).LT.1.D-5 )) THEN
                NAZ = 2
             ENDIF
          ENDIF
      ENDIF
*
      CALL  dpszeroit( UU, MAXUMU*MAXULV*MAXPHI )
    
      DO MAZ = 0, NAZ

         IF ( MAZ.EQ.0 )  DELM0 = 1.0D0
         IF ( MAZ.GT.0 )  DELM0 = 0.0D0
*
*   
*        SINGLE SCATTERING
*
         do I=1,mxcmu
           cwt0(I)=cwt(I)
	 enddo
*	  
         IF (NSCA.EQ.1) THEN 
            CALL dpszeroit( CWT, MXCMU )
         ENDIF
*      
         CALL dpqfoucom(cwt0,
     $        accur, acmu, albedo, bdr, beta, bplank, btemp,
     $        ch, chtau, cmu, cwt, delm0, deltam, deltamu, dtauc, 
     $        EXPbea, fbeam, fisot, flyr, gl, layru, 
     $        layru_c, lyrcut, maxcly, maxcmu, maxulv, maxumu, maz, 
     $        ncut, nil, nlyr, noplnk, nn, nstr, ntau, ntau_c, 
     $        numu, numu_c, numu_u, onlyfl, oprim, pi, pkag, pkagc, 
     $        pmom, prnt, radius, spher, ssalb, tauc,  
     $        taucpr, temis, temper, tplank, ttemp, umu0, umu, 
     $        umu_c, umu_u, usrang, utau, utau_c, utaupr, 
     $        utaupr_c, utaupr_u, wvnmhi, wvnmlo, zd,
     $        dfdt, flup, fldn, fldir, rfldir,rfldn, uavg, 
     $        u0u, uum, u0uls, uavgdn, uavgso, uavgup, qsrc(1,0,MAZ+1),
     $        qsrcu(1,0,MAZ+1), gsrc, debug, iwarn  )
        
 
      IF( MAZ.EQ.0 ) THEN
C
         DO  140  J = 1, NPHI
            PHIRAD( J ) = RPD * ( PHI(J) - PHI0 )
 140     CONTINUE
C                               ** SAVE AZIMUTHALLY AVERAGED INTENSITIES
         DO 160  LU = 1, NTAU
            DO 160  IU = 1, NUMU
               U0U( IU,LU ) = UUM( IU,LU,0 )
 160     CONTINUE
C
      END IF
C                                ** INCREMENT INTENSITY BY CURRENT
C                                ** AZIMUTHAL COMPONENT (FOURIER
C                                ** COSINE SERIES);  EQ SD(2)
      AZERR = 0.D0
      DO  J = 1, NPHI
         COSPHI = DCOS( MAZ * PHIRAD(J) )
         DO  LU = 1, NTAU
            DO IU = 1, NUMU
               AZTERM = UUM( IU,LU,MAZ ) * COSPHI
               UU( IU,LU,J ) = UU( IU,LU,J ) + AZTERM
               AZERR = dmax1(dpsratio( DABS(AZTERM), DABS(UU(IU,LU,J))),
     $                        AZERR )
            ENDDO
         ENDDO
      ENDDO

      DO   LU = 1, NTAU
         DO   IU = 1, NUMU
            guum(IU,LU,maz) = UUM( IU,LU,MAZ )
         ENDDO
      ENDDO


      IF ( AZERR.LE.ACCUR )  KCONV = KCONV + 1
      IF ( KCONV.GE.2 )   then
       GOTO 210
      endif 
C
      ENDDO
*
210   CONTINUE
*     
      IF( PRNT( 5 ) .AND. .NOT.ONLYFL ) THEN
         CALL dpPRTINT( UU, UTAU, NTAU, UMU, NUMU, PHI, 
     $        NPHI, MAXULV, MAXUMU )
      ENDIF
      
      RETURN
C
1010  FORMAT ( ////, 1X, 120('*'), /, 25X,
     $  'Spherical version of disort',
     $  /, 1X, A, /, 1X, 120('*') )
      END
*
      SUBROUTINE dpqfoucom(cwt0, accur, acmu, albedo, bdr, beta, bplank,
     $     btemp, ch, chtau, cmu, cwt, delm0, deltam, deltamu, dtauc, 
     $     EXPbea, fbeam, fisot, flyr, gl, layru, layru_c, 
     $     lyrcut, maxcly, maxcmu, maxulv, maxumu, maz, ncut,
     $     nil, nlyr, noplnk, nn, nstr, ntau, ntau_c, numu, numu_c,
     $     numu_u, onlyfl, oprim, pi, pkag, pkagc, pmom, prnt, radius, 
     $     spher, ssalb, tauc, taucpr,  temis, temper, 
     $     tplank, ttemp, umu0, umu, umu_c, umu_u, usrang, utau, 
     $     utau_c, utaupr, utaupr_c, utaupr_u, wvnmhi, wvnmlo, 
     $     zd, dfdt, flup, fldn, fldir, rfldir, rfldn,
     $     uavg, u0u, uum, u0uls, uavgdn, uavgso, uavgup, 
     $     qsrc, qsrcu, gsrc, debug, iwarn )
*
*     Solve Eq. 6a (STWJ) for each FOUrier COMponent
*     
      implicit double precision (A-H, O-Z)

C+---------------------------------------------------------------------+
C   LOCAL SYMBOLIC DIMENSIONS:
C
C       MXCLY  = Max no. of computational layers
C       MXULV  = Max no. of output levels
C       MXCMU  = Max no. of computation polar angles
C       MXUMU  = Max no. of output polar angles
c       MXPHI  = Max no. of output azimuthal angles
C+---------------------------------------------------------------------+
      INTEGER MXCLY, MXULV, MXCMU, MXUMU, MXPHI,
     $        MI, MI9M2, NNLYRI 
      INCLUDE 'DISORT.MXD'
      PARAMETER ( MI = MXCMU/2, MI9M2 = 9*MI-2,
     $     NNLYRI = MXCMU*MXCLY )
*
      INTEGER iwarn
      INTEGER ipvt(nnlyri), layru(mxulv)
      LOGICAL lamber, LYRCUT, gsrc
      LOGICAL debug
      LOGICAL  DELTAM, NOPLNK, onlyfl, PRNT(7), SPHER, usrang
      real*8     accur, ALBEDO, beta(0:maxcly), 
     $     bplank, BTEMP, delm0, deltamu, DTAUC( MAXCLY ), FBEAM,
     $     FISOT, pi, PMOM( 0:MAXCMU, MAXCLY ), RADIUS,
     $     SSALB( MAXCLY ), TEMPER( 0:MAXCLY ), TEMIS, tplank, TTEMP,
     $     WVNMLO, WVNMHI, UMU0, UTAU( MAXULV ), 
     $     U0U(MAXUMU, MAXULV), ZD( 0:MAXCLY ), 
     $     qsrc(MAXCMU, 0:2*MAXCLY), qsrcu(MAXUMU, 0:2*MAXCLY)
      real*8     RFLDIR( MAXULV ), RFLDN( MAXULV ),
     $     FLUP( MAXULV ), 
     $     UAVG( MAXULV ), DFDT( MAXULV ), umu( maxumu ),
     $     UAVGDN( MAXULV ), UAVGUP( MAXULV ), UAVGSO( MAXULV )
*
      real*8    acmu(mxcmu), albedos,
     $     amb( mi,mi ), apb( mi,mi ),
     $     array( mxcmu,mxcmu ), b( nnlyri ), bdr( mi,0:mi ), 
     $     cband( mi9m2,nnlyri ), cc( mxcmu,mxcmu ), cerr, cdiff,
     $     ch( mxcly ), chtau(0:*), cmu( mxcmu ), cwt( mxcmu ),
     $     cwt0(mxcmu),  
     $     eval(mi), evecc( mxcmu, mxcmu ), 
     $     EXPbea( 0:mxcly ), dfdts(mxulv), fbeams, flups(mxulv), 
     $     flyr( mxcly ), fldn( mxulv ), fldir( mxulv ), 
     $     gl( 0:mxcmu,mxcly ), gc(mxcmu,mxcmu,mxcly ), 
     $     gu( mxumu, mxcmu, mxcly ), kk( mxcmu, mxcly ), 
     $     ll( mxcmu,mxcly ), oprim( mxcly ), pkag( 0:mxcly ),
     $     pkagc(mxcly), prev_cerr, psi0( mxcmu ), psi1( mxcmu ),
     $     rfldns(mxulv), rfldirs(mxulv), sgn, tauc( 0:mxcly ),
     $     taucpr( 0:mxcly ), tynt, 
     $     u0c( mxcmu,mxulv ), uavgs( mxulv ),
     $     u0uls(mxumu, mxulv), u0utmp(mxumu, mxulv),
     $     uum( mxumu, mxulv,0:mxcmu), utaupr( mxulv ), wk( mxcmu ),
     $     xr0(mxcly ), xr1( mxcly ), xra(mxcly), ylm0( 0:mxcmu ),
     $     ylmc(0:mxcmu,mxcmu ),ylmu(0:mxcmu, mxumu), z( nnlyri ),
     $     xba(mxcly ), xb0( mxcmu,mxcly ), xb1( mxcmu,mxcly ),
     $     zbeama(mxcly ), zbeam0( mxcmu,mxcly ), 
     $     zbeam1( mxcmu,mxcly ), zbs0(mxcmu ), zbsa, 
     $     zbs1( mxcmu ),
     $     xga(mxcly ), xg0( mxcmu,mxcly ), xg1( mxcmu,mxcly ),
     $     zgena(mxcly ), zgen0( mxcmu,mxcly ), 
     $     zgen1( mxcmu,mxcly ), zgs0(mxcmu ), zgsa, 
     $     zgs1( mxcmu ),
     $     z0( 2*mxcmu ),
     $     z1(2*mxcmu ), za, zj0(mxcmu ), zj1(mxcmu ), zj2( mxcmu ),
     $     zj( mxcmu ),  zju( mxumu), zplk0( mxcmu,mxcly ),
     $     zplk1( mxcmu,mxcly ), zplka(mxcly), zb0u( mxumu, mxulv ),
     $     zb1u( mxumu, mxulv ), zbau( mxumu,mxulv),
     $     zp0u( mxumu, mxulv), zp1u( mxumu, mxulv ),
     $     zpau(mxumu,mxulv),
     $     zg0u( mxumu, mxulv), zg1u( mxumu, mxulv ),
     $     zgau(mxumu,mxulv)
*
*     Variables for the internal source at computational angles
*
      INTEGER ntau_c, numu_c, layru_c( mxulv ), nil
      real*8 gu_c( 2*mxumu, mxcmu, mxcly ),
     $     parmu_c(mxcmu, mxulv), utau_c(mxcly+1),
     $     umu_c( 2*mxcmu ),  utaupr_c( mxulv ),
     $     ylmu_c(0:mxcmu, 2*mxumu),
     $     zb0u_c( 2*mxumu, mxulv ), zb1u_c( 2*mxumu, mxulv ), 
     $     zbau_c( 2*mxumu,mxulv), uum_c( 2*mxumu, mxulv, 0:mxcmu)
*
*     Variables for the internal source at user angles
*
      INTEGER numu_u
      real*8 gu_u( 2*mxumu, mxcmu, mxcly ), 
     $     parmu_u(mxcmu, mxulv), 
     $     umu_u( 2*mxcmu ), 
     $     xba_u(mxcly ), xb0_u( mxcmu,mxcly ), xb1_u( mxcmu,mxcly ),
     $     ylmu_u(0:mxcmu, 2*mxumu),
     $     zb0u_u( 2*mxumu, mxulv ), zb1u_u( 2*mxumu, mxulv ), 
     $     zbau_u( 2*mxumu,mxulv),
     $     zg0u_u( 2*mxumu, mxulv ), zg1u_u( 2*mxumu, mxulv ), 
     $     zgau_u( 2*mxumu,mxulv),
     $     uum_u( 2*mxumu, mxulv, 0:mxcmu),
     $     zj0_u(mxcmu ), zj1_u(mxcmu ), zj2_u( mxcmu ), zj_u( mxcmu )
*
*     This are just dummies, never used for anything, but
*     to avoid memory havocking when calling *sterpso*
*
      real*8   zp0u_c( 2*mxumu, mxulv), 
     $    zp1u_c( 2*mxumu, mxulv ), zpau_c( 2*mxumu,mxulv)
*
      DOUBLE PRECISION   AAD( MI,MI ), EVALD( MI ) , EVECCD( MI,MI ),
     $     WKD( MXCMU )
      DOUBLE PRECISION d1mach
*
      SAVE ylmc, ylm0, ylmu
*
*     No bidirectional reflectance here, so set lamber .true.
*
      lamber = .true.
      
   
*
*     Zero some stuff just to make sure....
*
      
      DO 10 I = 1, NNLYRI
         IPVT(I) = 0
10    CONTINUE
      CALL dpszeroit( dfdts, mxulv )
      CALL dpszeroit( flups, mxulv )
      CALL dpszeroit( rfldns, mxulv )
      CALL dpszeroit( rfldirs, mxulv )
      CALL dpszeroit( uavgs, mxulv )
      CALL dpszeroit( u0uls, mxumu*mxulv )
      CALL dpszeroit( u0utmp, mxumu*mxulv )
      CALL  dpszeroit( AMB, MI**2 )
      CALL  dpszeroit( APB, MI**2 )
      CALL  dpszeroit( ARRAY, MXCMU**2 )
      CALL  dpszeroit( CC,    MXCMU**2 )
      CALL  dpszeroit( EVAL  ,MI )
      CALL  dpszeroit( EVECC, MXCMU**2 )
      CALL  dpszeroit( gc, mxcmu*MXCMU*MXCLY )
      CALL  dpszeroit( GU, mxumu*MXCMU*MXCLY )
      CALL  dpszeroit( KK,     MXCMU*MXCLY )
      CALL  dpszeroit( LL,     MXCMU*MXCLY )
      CALL  dpszeroit( WK    ,  MXCMU )
      CALL  dpszeroit( xba, MXCLY )
      CALL  dpszeroit( xb0, MXCMU*MXCLY )
      CALL  dpszeroit( xb1, MXCMU*MXCLY )
      CALL  dpszeroit( xga, MXCLY )
      CALL  dpszeroit( xg0, MXCMU*MXCLY )
      CALL  dpszeroit( xg1, MXCMU*MXCLY )
      CALL  dpszeroit( XR0, MXCLY )
      CALL  dpszeroit( XR1, MXCLY )
      CALL  dpszeroit( XRA, MXCLY )
      CALL  dpszeroit( Z, NNLYRI )
      CALL  dpszeroit( Z0    ,  MXCMU )
      CALL  dpszeroit( Z1    ,  MXCMU )
      ZA = 0
      CALL  dpszeroit( ZBEAMA, MXCLY )
      CALL  dpszeroit( ZBEAM0, MXCMU*MXCLY )
      CALL  dpszeroit( ZBEAM1, MXCMU*MXCLY )
      CALL  dpszeroit( ZBS0, MXCMU )
      CALL  dpszeroit( ZBS1, MXCMU )
      CALL  dpszeroit( zgena, MXCLY )
      CALL  dpszeroit( zgen0, MXCMU*MXCLY )
      CALL  dpszeroit( zgen1, MXCMU*MXCLY )
      zgsa = 0
      zbsa = 0
      CALL  dpszeroit( ZJ,  MXCMU )
      CALL  dpszeroit( ZPLK0,  MXCMU*MXCLY )
      CALL  dpszeroit( ZPLK1,  MXCMU*MXCLY )
      CALL  dpszeroit( ZPLKA,  MXCLY )
*
      CALL  dpszeroit( zbau, mxumu*mxulv )
      CALL  dpszeroit( zb0u, mxumu*mxulv )
      CALL  dpszeroit( zb1u, mxumu*mxulv )
      CALL  dpszeroit( zgau, mxumu*mxulv )
      CALL  dpszeroit( zg0u, mxumu*mxulv )
      CALL  dpszeroit( zg1u, mxumu*mxulv )
      CALL  dpszeroit( zbau, mxumu*mxulv )
      CALL  dpszeroit( zp0u, mxumu*mxulv )
      CALL  dpszeroit( zp1u, mxumu*mxulv )
*
*     Only zero these the first time, otherwise EXPect a downer
*
      IF ( maz .EQ. 0 ) THEN
         CALL  dpszeroit( YLM0, MXCMU+1 )
         CALL  dpszeroit( YLMC, (MXCMU+1)*MXCMU )
         CALL  dpszeroit( ylmu, (mxcmu+1)*mxumu )
      ENDIF
*
*
*     Get normalized associated legendre polynomials for incident beam
*     angle cosine
*
      IF ( FBEAM .GT. 0.0D0 )
     $     CALL  dpslepoly( 1, MAZ, MXCMU, NSTR-1, -UMU0, YLM0 )
*
*     Get normalized associated legendre polynomials for computational
*     polar angle cosines
*
      IF ( .NOT. onlyfl .AND. usrang ) THEN
         CALL dpslepoly( numu, maz, mxcmu, nstr-1, umu, ylmu )
         CALL dpslepoly( numu_u, maz, mxcmu, nstr-1, umu_u, ylmu_u )
      ENDIF
      CALL dpslepoly( numu_c, maz, mxcmu, nstr-1, umu_c, ylmu_c )
      CALL  dpslepoly( NN,   MAZ, MXCMU, NSTR-1, CMU, YLMC )
      
*
*     Evaluate normalized associated legendre polynomials with negative
*     -cmu- from those with positive -cmu-; Dave/Armstrong eq. (15)
*
      SGN  = - 1.0D0
      DO L = MAZ, NSTR-1
         SGN = - SGN
         DO  IQ = NN+1, NSTR
            YLMC( L,IQ ) = SGN * YLMC( L,IQ-NN )
         ENDDO
      ENDDO

*     
*     
*     
      albedos  = albedo
      fbeams   = fbeam
      prev_cerr = d1mach(2)
     
*
* ===== Begin loop over each term in Eq. 10, Dahlback and Stamnes (1991)
*
      DO 99 il = 0, nil
*
*     For all but the pseudo-spherical approximation (il=0) set
*     fbeam=0.0 and albedo=0.0.
*
         IF ( il .GT. 0 ) THEN
            albedo = 0.0D0
            fbeam  = 0.0D0
         ENDIF
*     
C
C ===================  BEGIN LOOP ON COMPUTATIONAL LAYERS  =============
C
         DO 100  LC = 1, NCUT
*
*     Solve eigenfunction problem in eq. stwj(8b); return eigenvalues
*     and eigenvectors
*
            CALL dpssoleig( amb, apb, array, cmu, cwt, gl(0,lc),mi, maz,
     $           mxcmu, nn, nstr, wk, ylmc, cc, evecc, eval,
     $           kk(1,lc), gc(1,1,lc), aad, wkd, eveccd, evald, umu0 )
*
*     Set coefficients in ks(7)
*
*     For the beam source or for the perturbation source
*
            IF ( FBEAM.GT.0.D0 .OR. il.GT.0 .OR. gsrc) THEN
*
               
               IF ( il .EQ. 0 ) THEN
	        
*
*     Set coefficients for the internal source for il=0
*               
              
                  CALL dpqsetbco( ch, chtau, cmu, delm0, fbeam,
     $                 gl, lc, maz, mxcmu, nstr, 
     $                 taucpr, xba, xb0, xb1, zj, 
     $                 ylmc, ylm0)

*
*     Set coefficients for the general source for il=0
*               
                  IF ( gsrc ) THEN

                     CALL gsetbco( ch, cmu, lc, mxcmu, maxcmu, nstr, 
     $                    xga, xg0, xg1, qsrc, taucpr, 
     $                    zj, zj0, zj1, zj2 )
                     
                  ENDIF

*
*     Get coefficients at cmu+-deltamu
*                  
                  IF ( nil .GT. 0 ) THEN
		    
                     CALL dpintbco( chtau, delm0,  fbeam, gl, lc, maz,
     $                    mxcmu, 2*mxumu, nstr, numu_c,
     $                    taucpr, zb0u_c, zb1u_c, xba,
     $                    zju, ylm0, ylmu_c)
                 
                  ENDIF
*     
                  IF ( usrang ) THEN
*     
*     Get coefficients at umu
*     
                     IF ( FBEAM .GT. 0.0 ) THEN
                        CALL dpintbco( chtau, delm0,  fbeam, gl,
     $                       lc, maz, mxcmu, mxumu, nstr, numu,
     $                       taucpr, zb0u, zb1u, xba,
     $                       zju, ylm0, ylmu)
                     ENDIF
                     IF ( gsrc ) THEN
                        CALL dpqintbco( qsrcu, lc, maz, maxumu,
     $                       mxumu, numu, taucpr, zg0u, zg1u, xga )
                     ENDIF
*     
*     Get coefficients at umu+-deltamu
*     
                     IF ( nil .GT. 0 ) THEN
                        CALL dpintbco( chtau, delm0,  fbeam, gl, lc,
     $                       maz, mxcmu, 2*mxumu, nstr, numu_u,
     $                       taucpr, zb0u_u, zb1u_u, xba,
     $                       zju, ylm0, ylmu_u)
                        
                     ENDIF
                  ENDIF
*
               ELSE
	          
*
*     Set coefficients for the internal source for il > 0
*
                 
                  CALL dpsetpar( acmu, beta, lc, mxcmu, nstr, parmu_c,
     $                 radius,taucpr, xba, xb0, xb1, zd, zj, zj0, zj2 )
               
                  
*
*     Do some index gymnastic to satisfy the fantastic representation
*     of angles in cmu.
*
*     ooooh, bananas.....
*
                  DO iq = 1, nn
                     z0(2*iq-1)      = xb0(nstr+1-iq,lc)
                     z0(2*iq)        = xb0(nstr+1-iq,lc)
                     z0(2*nn+2*iq-1) = xb0(iq,lc)
                     z0(2*nn+2*iq)   = xb0(iq,lc)
                     z1(2*iq-1)      = xb1(nstr+1-iq,lc)
                     z1(2*iq)        = xb1(nstr+1-iq,lc)
                     z1(2*nn+2*iq-1) = xb1(iq,lc)
                     z1(2*nn+2*iq)   = xb1(iq,lc)
                  ENDDO
*     
                  DO iu = 1, numu_c
                     zb0u_c(iu,lc) = z0(iu)
                     zb1u_c(iu,lc) = z1(iu)
                  ENDDO
*
                 
                  IF ( usrang) THEN
                     CALL dpsetpar( umu_u, beta, lc, mxcmu, numu_u,
     $                    parmu_u, radius, taucpr, xba_u, xb0_u,
     $                    xb1_u, zd, zj_u, zj0_u, zj2_u )
*     
                     DO iu = 1, numu
                        zb0u(iu,lc) = xb0_u(iu,lc)
                        zb1u(iu,lc) = xb1_u(iu,lc)
                     ENDDO
                  ENDIF
               ENDIF
*
*     Calculate particular solutions of Eqs. ks(10-11) for incident
*     beam source in pseudo-spherical geometry
*

                              
               IF ( fbeam .gt. 0.0 ) THEN
               CALL dpsupbeam( array, cc, cmu, ipvt, mxcmu, nn, nstr, 
     $              wk, xb0(1,lc), xb1(1,lc), xba(lc), 
     $              zbs0, zbs1, zbsa, zbeam0(1,lc), zbeam1(1,lc), 
     $              zbeama(lc) )
               endif
                 
*
*     Calculate particular solutions of Eqs. ks(10-11) for general source
*               
               IF ( gsrc ) THEN
caky                  CALL dpqupbeam( array, cc, cmu, ipvt, mxcmu, nn, nstr,
                  CALL dpsupbeam( array, cc, cmu, ipvt, mxcmu, nn, nstr,
     $                 wk, xg0(1,lc), xg1(1,lc), xga(lc), 
     $                 zgs0, zgs1, zgsa, zgen0(1,lc),
     $                 zgen1(1,lc), zgena(lc))
caky     $                 zgen1(1,lc), zgena(lc), iwarn )
               ENDIF

*
*     and now a nip-up....
*     I got this from Arne Dahlback, numerical problems may happen
*     (even in double precision) if the perturbation source is not
*     ignored for optically thin layers. The value for tynt is from
*     Arne. (and tynt is norwegian and means thin).
*
               tynt = 0.001D0
               IF ( tauc(lc).LT.tynt .AND. il .GT. 0 ) THEN
                  CALL dpszeroit(zbs0,mxcmu)
                  CALL dpszeroit(zbs1,mxcmu)
                  DO iq = 1, nstr
                     zbeam0(iq,lc) = 0.D0
                     zbeam1(iq,lc) = 0.D0
                  ENDDO
               ENDIF
            ENDIF
C     
          
            IF ( .NOT.NOPLNK .AND. MAZ.EQ.0 ) THEN
	      
*
*     Set coefficients in ks(7) for thermal source
*
               CALL dpsetpco( lc, pkag, pkagc, taucpr, xra, xr0, xr1)

*
*     Calculate particular solutions of Eq. ks(11) for thermal emission
*     source
*
               CALL dpsupisot( array, cc, cmu, ipvt, mxcmu, nn, nstr,
     $              oprim(lc), wk, xr0(lc), xr1(lc), xra(lc), z0,
     $              z1, za, zplk0(1,lc), zplk1(1,lc), zplka(lc))
            END IF
*
*     Interpolate eigenvectors and source terms to angles needed to
*     get the internal source, cf. Eq. 11c, DS.
*
            IF ( nil .GT. 0 ) THEN
               CALL dpqterpev( cwt, evecc, gl(0,lc), gu_c(1,1,lc), maz,
     $              mxcmu, 2*mxumu, nn, nstr, numu_c, wk, ylmc, ylmu_c,
     $              debug)
            ENDIF
*
            IF (il .GT. 0 )  THEN
               fbeam = 1.0 D0                ! Just to get beam-source 
            ENDIF                          ! interpolated for il .gt. 0
*                                          
*     
*     Standard disort way of interpolating source terms
*
*
*     First, interpolate to cmu+-deltamu to be able to calculate
*            derivative term
*     
            IF ( nil .GT. 0 ) THEN
	     
               CALL  dpqterpso( cwt, fbeam, gl(0,lc), maz,
     $              mxcmu, noplnk, numu_c, nstr, oprim(lc),
     $              ylmc, ylmu_c, psi0, psi1, gsrc,
     $              xr0(lc), xr1(lc), xra(lc), z0, z1, 
     $              zbs0, zbs1, zbsa, zgs0, zgs1, zgsa, 
     $              zb0u_c(1,lc), zb1u_c(1,lc), zbau_c(1,lc), 
     $              zp0u(1,lc), zp1u(1,lc), zpau(1,lc),   
     $              zg0u(1,lc), zg1u(1,lc), zgau(1,lc))   
            ENDIF
*
            IF ( usrang ) THEN
*
*     Second, interpolate to umu+-deltamu to be able to calculate
*            derivative term for user angles
*     
* NOT IMPLEMENTED FOR GENERAL SOURCE TERM
*
               IF ( nil .GT. 0 ) THEN
                  CALL  dpqterpso( cwt, fbeam, gl(0,lc), maz,
     $                 mxcmu, noplnk, numu_u, nstr, oprim(lc),
     $                 ylmc, ylmu_u, psi0, psi1, gsrc,
     $                 xr0(lc), xr1(lc), xra(lc), z0, z1,
     $                 zbs0, zbs1, zbsa, zgs0, zgs1, zgsa, 
     $                 zb0u_u(1,lc), zb1u_u(1,lc), zbau_u(1,lc), 
     $                 zp0u(1,lc), zp1u(1,lc), zpau(1,lc),   
     $                 zg0u_u(1,lc), zg1u_u(1,lc), zgau_u(1,lc))   
                  
               ENDIF
           ENDIF
*
            IF ( il .GT. 0 ) THEN
               fbeam = 0.0D0      ! Back to zero as it should be here
            ENDIF
*     
            IF ( .NOT.onlyfl .AND. usrang ) THEN
*
*     Interpolate eigenvectors to user angles
*
               CALL  dpqterpev( CWT, EVECC, GL(0,LC), GU(1,1,LC), MAZ,
     $              MXCMU,MXUMU, NN, NSTR, NUMU, WK, YLMC, YLMU, debug)
               CALL dpqterpev( cwt, evecc, gl(0,lc), gu_u(1,1,lc), maz,
     $              mxcmu, 2*mxumu, nn, nstr, numu_u, wk, ylmc, ylmu_u,
     $              debug)

*
*     Interpolate source terms to user angles
*
               IF (il .gt. 0 )  THEN
                  fbeam = 1.0D0   ! Just to get beam-source interpolated
               ENDIF
*
*     Standard disort way of interpolating source terms
*     
*

               CALL  dpqterpso( cwt, fbeam, gl(0,lc), maz,
     $              mxcmu, noplnk, numu, nstr, oprim(lc),
     $              ylmc, ylmu, psi0, psi1, gsrc,
     $              xr0(lc), xr1(lc), xra(lc), z0, z1,
     $              zbs0, zbs1, zbsa, zgs0, zgs1, zgsa, 
     $              zb0u(1,lc), zb1u(1,lc), zbau(1,lc), 
     $              zp0u(1,lc), zp1u(1,lc), zpau(1,lc),   
     $              zg0u(1,lc), zg1u(1,lc), zgau(1,lc))
*     

               IF (il .gt. 0 ) THEN
                  fbeam = 0.D0   ! Back to zero as it should be here
               ENDIF
*     
            END IF
C
C
 100     CONTINUE
*
* ===================  END LOOP ON COMPUTATIONAL LAYERS  ===============
*
*     Set coefficient matrix of equations combining boundary and layer
*     interface conditions
*
         IF ( il .GT. 0 ) CALL dpszeroit(bdr,mi*(mi+1))
         CALL  dpssetmtx( bdr, cband, cmu, cwt, delm0, gc, kk, 
     $        lyrcut, mi, mi9m2, mxcmu, ncol, ncut, 
     $        nnlyri, nn, nstr, taucpr, wk )
*     
*     Solve for constants of integration in homo-geneous solution 
*     (general boundary conditions)
*
         CALL  dpqsolve0( albedo, b, bplank, cband, cmu, cwt, 
     $        EXPbea, fbeam, fisot, il, ipvt, ll, lyrcut,
     $        maz, mi, mi9m2, mxcmu, ncol, ncut, nn, noplnk, 
     $        nstr,
     $        nnlyri, pi, tplank, taucpr, umu0, z, zbeam0,
     $        zbeam1, zbeama, zplk0, zplk1, zplka, zgen0,
     $        zgen1, zgena, gsrc, prnt )
*
*     Compute upward and downward sfluxes
*
         IF ( maz .eq. 0 ) THEN
            CALL dpqfluxes( ch, cmu, cwt0, fbeam, gc, il, kk, 
     $           layru, ll, lyrcut, mxcmu, mxulv, ncut, nn, 
     $           nstr, ntau, pi, prnt, ssalb, taucpr, umu0,
     $           utau, utaupr, xr0, xr1, xra, zplk0,
     $           zplk1, zplka, zbeama, zbeam0, zbeam1, 
     $           zgen0, zgen1, zgena, gsrc,
     $           dfdt, 
     $           flup, fldn, fldir, rfldir, rfldn, 
     $           uavg, u0c, maxulv, uavgdn, uavgso, uavgup,
     $           debug)
*     
         ENDIF
*
*     Compute intensity components at
*     angles needed to calculate the derivative term in Eq. 11c
*     at computational angles.
*
     
         IF ( nil .GT. 0 ) THEN

            CALL  dpqusrint( albedo, bplank, cmu, cwt, delm0, EXPbea,
     $           fbeam, fisot, gc, gu_c, il, kk, lamber, layru_c, ll,
     $           lyrcut, maz, mxcmu, mxulv, 2*mxumu, ncut,
     $           nlyr, nn, nstr, noplnk, numu_c, ntau_c, pi, 
     $           taucpr, tplank, umu_c, umu0, utaupr_c, wk,
     $           zb0u_c, zb1u_c, zbau_c, zbeam0, zbeam1, zbeama,
     $           zp0u_c, zp1u_c, zpau_c, zplk0, zplk1, zplka, 
     $           zg0u, zg1u, zgau, zgena, zgen0, zgen1, 
     $           gsrc, uum_c, debug, prnt )
         ENDIF
*     
         IF ( usrang ) THEN
*
*     Compute azimuthal averaged intensity components at
*     user angles.
*          

            CALL  dpqusrint( albedo, bplank, cmu, cwt, delm0, EXPbea,
     $           fbeam, fisot, gc, gu, il, kk, lamber, layru, ll,
     $           lyrcut, maz, mxcmu, mxulv, mxumu, ncut,
     $           nlyr, nn, nstr, noplnk, numu, ntau, pi, 
     $           taucpr, tplank, umu, umu0, utaupr, wk,
     $           zb0u, zb1u, zbau, zbeam0, zbeam1, zbeama,
     $           zp0u, zp1u, zpau, zplk0, zplk1, zplka,
     $           zg0u, zg1u, zgau, zgena, zgen0, zgen1, 
     $           gsrc, uum, debug, prnt )
*
           
            DO lu = 1, ntau
               DO iu = 1, numu
                  u0utmp( iu,lu ) = u0utmp( iu,lu ) + uum( iu,lu, maz )
               ENDDO
            ENDDO
         ELSE 
*                                     ** Compute azimuthal averaged 
*                                     ** intensity components at
*                                     ** quadrature angles 
            DO lu = 1, ntau
               DO 130 iu = 1, nstr
                  u0utmp( iu,lu ) = u0utmp( iu,lu ) + uum( iu,lu, maz )
 130           CONTINUE
            ENDDO
         END IF
*
*     Check for convergence in Eq. 10, Dahlback and Stamnes (1991).
*      
         cerr  = 0.D0
         DO lu = 1, ntau
            IF ( il .GT. 0 ) THEN
               DO iu = 1, numu
                  IF (DABS(uum(iu,lu,maz)) .GT. 1.0D-09 ) THEN
                     cdiff = DABS( uum(iu,lu,maz) / u0utmp(iu,lu))
                  ELSE
                     cdiff = 0.D0
                  ENDIF
                  cerr = dmax1( cdiff, cerr )
               ENDDO
            ENDIF
         ENDDO
*
*     If cerr is not increasing save results from iteration
*
         IF ( cerr .LT. prev_cerr ) THEN
            IF ( maz .eq. 0 ) THEN
               DO lu = 1, ntau
                  dfdts(lu)    =  dfdts(lu)   + dfdt(lu)
                  flups(lu)    =  flups(lu)   + flup(lu)
                  rfldns(lu)   =  rfldns(lu)  + rfldn(lu)
                  rfldirs(lu)  =  rfldirs(lu) + rfldir(lu)
                  uavgs(lu)    =  uavgs(lu)   + uavg(lu)
               ENDDO
            ENDIF
            IF ( usrang ) THEN
               DO lu = 1, ntau
                  DO iu = 1, numu
                     u0uls( iu,lu ) = u0uls( iu,lu ) + uum( iu,lu, maz )
                  ENDDO
               ENDDO
            ELSE 
               DO lu = 1, ntau
                  DO  iu = 1, nstr
                     u0uls( iu,lu ) = u0uls( iu,lu ) + uum( iu,lu, maz )
                  ENDDO
               ENDDO
            END IF            
         ENDIF
         IF ( ( ( cerr .LT. accur ) .OR.
     $        ( cerr .GT. prev_cerr ) )
     $        .AND. il .GT. 0 ) GOTO 98
         IF ( il .GT. 0 ) prev_cerr = cerr
*     
*     Calculate the partial derivative of the intensity with respect to
*     the cosine of the polar angle for angles needed to calculate the
*     derivative term in Eq. 11c at computational angles.
*     
         IF ( nil .GT. 0 ) THEN
            CALL dpPARDER( deltamu, maz, mxcmu, mxulv, 2*mxumu, ntau_c,
     $           nstr, parmu_c, uum_c )
         ENDIF
*
         IF ( usrang ) THEN
            CALL dpPARDER( deltamu, maz, mxcmu, mxulv, 2*mxumu, ntau_c,
     $           numu_u/2, parmu_u, uum_u )
         ENDIF
*
 99   CONTINUE
*
 98   CONTINUE
*      
*
      IF ( maz .EQ. 0 ) THEN
         DO lu = 1, ntau
            dfdt(lu)  = dfdts(lu)
            uavg(lu)  = uavgs(lu)
            flup(lu)  = flups(lu)
            rfldn(lu) = rfldns(lu)
            rfldir(lu)= rfldirs(lu)
         ENDDO
      ENDIF
      albedo = albedos
      fbeam  = fbeams
*
      RETURN
      END
*     
*
      SUBROUTINE  dpqterpev( CWT, EVECC, GL, GU, MAZ, MXCMU, MXUMU,
     $                    NN, NSTR, NUMU, WK, YLMC, YLMU, debug )
C
C         INTERPOLATE EIGENVECTORS TO USER ANGLES; EQ SD(8)
C
      implicit double precision (A-H, O-Z)
      integer l, iq, numu, nstr, nn, mxumu, mxcmu, maz, iu, jq
      real*8  CWT(*), EVECC( MXCMU,* ), GL(0:*),
     $     GU(  MXUMU,* ), WK(*),
     $      YLMC(  0:MXCMU,* ), YLMU(  0:MXCMU,* )
      real*8 sum
      logical debug
C
C
      DO 50  IQ = 1, NSTR
C
         DO 20  L = MAZ, NSTR-1
C                                       ** INNER SUM IN SD(8) TIMES ALL
C                                   ** FACTORS IN OUTER SUM BUT PLM(MU)
            SUM = 0.D0
            DO 10  JQ = 1, NSTR
               SUM = SUM + CWT(JQ) * YLMC(L,JQ) * EVECC(JQ,IQ)      
10          CONTINUE
            WK(L+1) = 0.5D0 * GL(L) * SUM
20       CONTINUE
C                                    ** FINISH OUTER SUM IN SD(8)
C                                    ** AND STORE EIGENVECTORS
         DO 40  IU = 1, NUMU
            SUM = 0.D0
            DO 30  L = MAZ, NSTR-1
               SUM = SUM + WK(L+1) * YLMU(L,IU)
30          CONTINUE
            IF ( IQ.LE.NN )  GU( IU, IQ+NN     ) = SUM
            IF ( IQ.GT.NN )  GU( IU, NSTR+1-IQ ) = SUM
40       CONTINUE
C
50    CONTINUE
C
      RETURN
      END

      SUBROUTINE  dpqfluxes(CH, CMU, CWT, FBEAM, GC, il, KK, LAYRU, LL,
     $                    LYRCUT, MXCMU, MXULV, NCUT, NN, NSTR, NTAU,
     $                    PI, PRNT, SSALB, TAUCPR, UMU0, UTAU, UTAUPR,
     $                    XR0, XR1, XRA, ZPLK0, ZPLK1, ZPLKA, ZBEAMA, 
     $                    ZBEAM0, ZBEAM1, zgen0, zgen1, zgena, gsrc,
     $                    DFDT, FLUP, FLDN, FLDIR, 
     $                    RFLDIR, RFLDN, UAVG, U0C, MAXULV,
     $                    uavgdn, uavgso, uavgup, debug)
*
*     Modified from original disort sfluxes routine to include il in the
*     parameter list and to use the EXPonential-linear approximation
*     for the beam source.
*
C
C       CALCULATES THE RADIATIVE FLUXES, MEAN INTENSITY, AND FLUX
C       DERIVATIVE WITH RESPECT TO OPTICAL DEPTH FROM THE M=0 INTENSITY
C       COMPONENTS (THE AZIMUTHALLY-AVERAGED INTENSITY)
C
C    I N P U T     V A R I A B L E S:
C
C      
C       CMU      :  ABSCISSAE FOR GAUSS QUADRATURE OVER ANGLE COSINE
C       CWT      :  WEIGHTS FOR GAUSS QUADRATURE OVER ANGLE COSINE
C       GC       :  EIGENVECTORS AT POLAR QUADRATURE ANGLES, SC(1)
C       KK       :  EIGENVALUES OF COEFF. MATRIX IN EQ. SS(7)
C       LAYRU    :  LAYER NUMBER OF USER LEVEL -UTAU-
C       LL       :  CONSTANTS OF INTEGsratioN IN EQ. SC(1), OBTAINED
C                   BY SOLVING SCALED VERSION OF EQ. SC(5);
C                   EXPONENTIAL TERM OF EQ. SC(12) NOT INCLUDED
C       LYRCUT   :  LOGICAL FLAG FOR TRUNCATION OF COMPUT. LAYER
C       NN       :  ORDER OF DOUBLD-GAUSS QUADRATURE (NSTR/2)
C       NCUT     :  NUMBER OF COMPUTATIONAL LAYER WHERE ABSORPTION
C                     OPTICAL DEPTH EXCEEDS -ABSCUT-
C       TAUCPR   :  CUMULATIVE OPTICAL DEPTH (DELTA-M-SCALED)
C       UTAUPR   :  OPTICAL DEPTHS OF USER OUTPUT LEVELS IN DELTA-M
C                     COORDINATES;  EQUAL TO  -UTAU- IF NO DELTA-M
C       XR0      :  EXPANSION OF THERMAL SOURCE FUNCTION IN EQ. KS(4)
C       XR1      :  EXPANSION OF THERMAL SOURCE FUNCTION EQS. KS(4)
C       XRA      :  EXPANSION OF THERMAL SOURCE FUNCTION EQS. KS(4)
C       ZBEAMA   :  BEAM SOURCE COEFFICIENT ALFA IN EQ.KS(6)
C       ZBEAM0   :  BEAM SOURCE VECTORS Y-SUB-ZERO IN EQ.KS(6)
C       ZBEAM1   :  BEAM SOURCE VECTORS Y-SUB-ONE IN EQ.KS(6)
C       ZPLK0    :  THERMAL SOURCE VECTORS -Z0-, BY SOLVING EQ. KS(7-8)
C       ZPLK1    :  THERMAL SOURCE VECTORS -Z1-, BY SOLVING EQ. KS(7-8)
C       ZPLKA    :  THERMAL SOURCE COEFFICIENT -ZA-, 
C                   ALFA IN EQ. KS(6)
C       (REMAINDER ARE 'DISORT' INPUT VARIABLES)
C
C   O U T P U T     V A R I A B L E S:
C
C       U0C      :  AZIMUTHALLY AVERAGED INTENSITIES
C                   ( AT POLAR QUADRATURE ANGLES )
C       (RFLDIR, RFLDN, FLUP, DFDT, UAVG ARE 'DISORT' OUTPUT VARIABLES)
C
C   I N T E R N A L       V A R I A B L E S:
C
C       DIRINT   :  DIRECT INTENSITY ATTENUATED
C       FDNTOT   :  TOTAL DOWNWARD FLUX (DIRECT + DIFFUSE)
C       FLDIR    :  DIRECT-BEAM FLUX (DELTA-M SCALED)
C       FLDN     :  DIFFUSE DOWN-FLUX (DELTA-M SCALED)
C       FNET     :  NET FLUX (TOTAL-DOWN - DIFFUSD-UP)
C       FACT     :  EXP( - UTAUPR / UMU0 )
C       PLSORC   :  PLANCK SOURCE FUNCTION (THERMAL)
C       ZINT     :  INTENSITY OF m = 0 CASE, IN EQ. SC(1)
C+---------------------------------------------------------------------+
C
      implicit double precision (A-H, O-Z)
      LOGICAL LYRCUT, PRNT(*), gsrc
      LOGICAL debug
      real*8    DFDT(*), FLUP(*), FLDIR(*), FLDN(*),
     $     RFLDIR(*), RFLDN(* ), 
     $     U0C( MXCMU,MXULV ), UAVG(*), uavgdn(*), uavgso(*),
     $     uavgup(*), umu0
      INTEGER LAYRU(*)
      real*8    CH(*), CMU(*), CWT(*),
     $     FBEAM, GC( MXCMU,MXCMU,* ), KK( MXCMU,* ),
     $     LL( MXCMU,* ), pi, SSALB(*), TAUCPR( 0:* ),
     $     UTAU(*), UTAUPR(*), XR0(*), XR1(*), XRA(*), 
     $     ZPLK0( MXCMU,* ), ZPLK1( MXCMU,* ), ZPLKA( * ) ,
     $     ZBEAMA(*), ZBEAM0(MXCMU,*), ZBEAM1(MXCMU,*),
     $     ZGEN0( MXCMU,* ),
     $     ZGEN1( MXCMU,* ), ZGENA( * ) 
      real*8 ang1, ang2, dirint, fact, fdntot,
     $     fnet, plsorc, zint
C
C
      
      
      IF ( PRNT(2) )  WRITE( *,1010 )
C                                          ** ZERO DISORT OUTPUT ARRAYS
      CALL  dpszeroit( U0C, MXULV*MXCMU )
      CALL  dpszeroit( RFLDIR, MAXULV )
      CALL  dpszeroit( FLDIR,  MXULV )
      CALL  dpszeroit( RFLDN,  MAXULV )
      CALL  dpszeroit( FLDN,   MXULV )
      CALL  dpszeroit( FLUP,   MAXULV )
      CALL  dpszeroit( UAVG,   MAXULV )
      CALL  dpsZEROIT( UAVGdn, MAXULV )
      CALL  dpsZEROIT( UAVGso, MAXULV )
      CALL  dpsZEROIT( UAVGup, MAXULV )
      CALL  dpszeroit( DFDT,   MAXULV )
C                                        ** LOOP OVER USER LEVELS
      DO 100  LU = 1, NTAU
C
         LYU = LAYRU(LU)
C
         IF ( LYRCUT .AND. LYU.GT.NCUT ) THEN
C                                                ** NO RADIATION REACHES
C                                                ** THIS LEVEL
            FDNTOT = 0.0D0
            FNET   = 0.0D0
            PLSORC = 0.0D0
            GO TO 90
         END IF
*
         IF ( FBEAM.GT.0.D0 )  THEN
            FACT  = DEXP( - UTAUPR(LU) / CH(LYU) )
            DIRINT = FBEAM * FACT
            FLDIR(  LU ) = DABS(UMU0) * ( FBEAM * FACT )
            RFLDIR( LU ) = DABS(UMU0)*FBEAM*DEXP( - UTAU( LU ) /
     $                                           CH(LYU) )         
*           
                               	    
         ELSE
            DIRINT = 0.D0
            FLDIR(  LU ) = 0.D0
            RFLDIR( LU ) = 0.D0
	   
         END IF
C
         DO 20  IQ = 1, NN
C
            ZINT = 0.D0
            DO 10  JQ = 1, NN
               ZINT = ZINT + GC(IQ,JQ,LYU) * LL(JQ,LYU) *
     $               DEXP( - KK(JQ,LYU) * (UTAUPR(LU) - TAUCPR(LYU)) )
10          CONTINUE
            DO 11  JQ = NN+1, NSTR
               ZINT = ZINT + GC(IQ,JQ,LYU) * LL(JQ,LYU) *
     $                DEXP( - KK(JQ,LYU) *
     $              (UTAUPR(LU) - TAUCPR(LYU-1)) )
11          CONTINUE
C
            U0C( IQ,LU ) = ZINT
            IF ( FBEAM.GT.0.D0 .OR. il.GT. 0 .OR. gsrc)  THEN
               U0C( IQ,LU ) = ZINT + 
     $           DEXP(-ZBEAMA(LYU)*UTAUPR(LU)) *
     $           ( ZBEAM0(IQ,LYU) +
     $           ZBEAM1(IQ,LYU)*UTAUPR(LU) )
     $           +
     $           DEXP(-zgena(lyu)*utaupr(lu)) *
     $           ( zgen0(iq,lyu) +
     $           zgen1(iq,lyu)*utaupr(LU) )
            ENDIF
            U0C( IQ,LU ) = U0C( IQ,LU ) +
     $                             DEXP(-ZPLKA(LYU)*UTAUPR(LU))*
     $                         (ZPLK0(IQ,LYU)+ZPLK1(IQ,LYU)*UTAUPR(LU))
            UAVG(LU) = UAVG(LU) + CWT(NN+1-IQ) * U0C( IQ,LU )
            UAVGdn(LU) = UAVGdn(LU) + CWT(NN+1-IQ) * U0C( IQ,LU )
            FLDN(LU) =FLDN(LU) + CWT(NN+1-IQ)*CMU(NN+1-IQ) * U0C(IQ,LU)
          
20       CONTINUE
C
         DO 40  IQ = NN+1, NSTR
C
            ZINT = 0.D0
            DO 30  JQ = 1, NN
               ZINT = ZINT + GC(IQ,JQ,LYU) * LL(JQ,LYU) *
     $                DEXP( - KK(JQ,LYU) * (UTAUPR(LU) - TAUCPR(LYU)) )
30          CONTINUE
            DO 31  JQ = NN+1, NSTR
               ZINT = ZINT + GC(IQ,JQ,LYU) * LL(JQ,LYU) *
     $                DEXP( - KK(JQ,LYU) *
     $              (UTAUPR(LU) - TAUCPR(LYU-1)) )
31          CONTINUE
C
            U0C( IQ,LU ) = ZINT
            IF ( FBEAM.GT.0.0D0 .OR. il.GT.0 .OR. gsrc) THEN
               U0C( IQ,LU )=ZINT + 
     $              DEXP(-ZBEAMA(LYU)*UTAUPR(LU))*
     $              ( ZBEAM0(IQ,LYU) +
     $              ZBEAM1(IQ,LYU)*UTAUPR(LU) )
     $              +
     $              DEXP(-zgena(lyu)*utaupr(lu))*
     $              ( zgen0(iq,lyu) +
     $              zgen1(iq,lyu)*utaupr(lu) )
            ENDIF
            U0C( IQ,LU ) = U0C( IQ,LU ) + 
     $                             DEXP(-ZPLKA(LYU)*UTAUPR(LU))*
     $                       (ZPLK0(IQ,LYU)+ZPLK1(IQ,LYU)*UTAUPR(LU))
            UAVG(LU) = UAVG(LU) + CWT(IQ-NN) * U0C( IQ,LU )
            UAVGup(LU) = UAVGup(LU) + CWT(IQ-NN) * U0C( IQ,LU )    
            FLUP(LU)=FLUP(LU) + CWT(IQ-NN)*CMU(IQ-NN)*U0C( IQ,LU )
         
40       CONTINUE
C

         FLUP( LU )  = 2.D0 * PI * FLUP( LU )
         FLDN( LU )  = 2.D0 * PI * FLDN( LU )
         FDNTOT = FLDN( LU ) + FLDIR( LU )
         FNET   = FDNTOT - FLUP( LU )
         RFLDN( LU ) = FDNTOT - RFLDIR( LU )
         UAVG( LU ) = (2.D0 * PI * UAVG(LU) + DIRINT)/( 4.D0*PI )
         UAVGdn( LU ) = ( 2.0 * PI * UAVGdn(LU) ) / ( 4.*PI )
         UAVGso( LU ) =  DIRINT  / ( 4.*PI )
         UAVGup( LU ) = ( 2.0 * PI * UAVGup(LU) ) / ( 4.*PI )
         PLSORC = DEXP(-XRA(LYU)*UTAUPR(LU))*
     $                          (XR0(LYU) + XR1(LYU)* UTAUPR(LU))
         DFDT( LU ) = ( 1.D0-SSALB(LYU) ) * 4.D0*PI*
     $        ( UAVG(LU) - PLSORC )
 90      IF( PRNT(2) )  WRITE( *,1020 ) UTAU(LU), LYU, RFLDIR(LU),
     $                                 RFLDN(LU), FDNTOT, FLUP(LU),
     $                                 FNET, UAVG(LU), PLSORC, DFDT(LU)
100   CONTINUE
C
      IF ( PRNT(3) )  THEN
         WRITE ( *,1100 )
         DO 200  LU = 1, NTAU
            WRITE( *,1110 )  UTAU( LU )
            DO  200  IQ = 1, NN
               ANG1 = 180.D0/PI * DACOS( CMU(2*NN-IQ+1) )
               ANG2 = 180.D0/PI * DACOS( CMU(IQ) )
               WRITE( *,1120 ) ANG1, CMU(2*NN-IQ+1), CWT(2*NN-IQ+1), 
     $              U0C(IQ,LU),
     $                         ANG2, CMU(IQ), CWT(IQ),   
     $              U0C(IQ+NN,LU)
200      CONTINUE
      END IF
C
1010  FORMAT( //, 21X,
     $ '<----------------------- qfluxes ----------------------->', /,
     $ '   OPTICAL  COMPU    DOWNWARD    DOWNWARD    DOWNWARD     ',
     $ ' UPWARD                    MEAN      PLANCK   D(NET FLUX)', /,
     $ '     DEPTH  LAYER      DIRECT     DIFFUSE       TOTAL     ',
     $ 'DIFFUSE         NET   INTENSITY      SOURCE   / D(OP DEP)', / )
1020  FORMAT( F10.4, I7, 1P,7(E12.3), E14.3 )
1100  FORMAT( //, ' ******** AZIMUTHALLY AVERAGED INTENSITIES',
     $      ' ( AT POLAR QUADRATURE ANGLES ) *******' )
1110  FORMAT( /, ' OPTICAL DEPTH =', F10.4, //,
     $  '     ANGLE (DEG)   COS(ANGLE)     INTENSITY',
     $  '     ANGLE (DEG)   COS(ANGLE)     INTENSITY' )
1120  FORMAT( 2( 0P,F16.4, F13.5, F13.5, 1P,E14.3 ) )
C
      RETURN
      END
*
      SUBROUTINE dpqprtinp( NLYR, DTAUC, SSALB, PMOM, TEMPER, WVNMLO,
     $                    WVNMHI, NTAU, UTAU, NSTR, numu, umu,
     $                    FBEAM, UMU0, spher, nil,
     $                    FISOT, ALBEDO, BTEMP, TTEMP, TEMIS, DELTAM, 
     $                    NOPLNK, onlyfl, FLYR, LYRCUT, OPRIM, 
     $                    TAUC, TAUCPR, MAXCMU, gsrc, PRTMOM )
C
C        PRINT VALUES OF INPUT VARIABLES
C
      implicit double precision (A-H, O-Z)
      LOGICAL  DELTAM, LYRCUT, NOPLNK, onlyfl, PRTMOM, spher, gsrc
      real*8 albedo, btemp, DTAUC(*), fbeam,
     $     fisot, FLYR(*), OPRIM(*), 
     $     PMOM( 0:MAXCMU,* ), SSALB(*), UTAU(*), TAUC( 0:* ),
     $     TAUCPR( 0:* ), temis, TEMPER( 0:* ), ttemp, 
     $     umu(*), umu0, wvnmhi, wvnmlo
      real*8 yessct
      integer nil
C
C
      WRITE( *,1010 )  NSTR, NLYR
      WRITE( *,1030 )  NTAU, (UTAU(LU), LU = 1, NTAU)
      IF ( .NOT. onlyfl )
     $      WRITE( *,1040 ) numu, ( umu(iu), iu = 1, numu )
      IF ( NOPLNK  )  WRITE( *,1100 )
      WRITE( *,1060 ) FBEAM, UMU0,  FISOT
      WRITE( *,1080 ) ALBEDO
      IF ( .NOT.NOPLNK )  WRITE( *,1110 ) WVNMLO, WVNMHI, BTEMP,
     $                                    TTEMP, TEMIS
      IF ( spher .AND. nil.EQ.0 ) WRITE(*,1111)
      IF ( spher .AND. nil.GT.0 ) WRITE(*,1112)
      IF ( .NOT. spher )          WRITE(*,1113)
      IF ( DELTAM )      WRITE( *,1120 )
      IF ( .NOT.DELTAM ) WRITE( *,1130 )
      IF ( gsrc ) WRITE( *,1140 )
      IF ( LYRCUT )  WRITE( *,1170 )
      IF( .NOT.NOPLNK )  WRITE ( *,1190 )
      IF(      NOPLNK )  WRITE ( *,1191 )
      YESSCT = 0.D0
      DO 10 LC = 1, NLYR
         YESSCT = YESSCT + SSALB(LC)
         IF( .NOT.NOPLNK )
     $       WRITE( *,1200 )  LC, DTAUC(LC), TAUC(LC), SSALB(LC),
     $                    FLYR(LC), TAUCPR(LC)-TAUCPR(LC-1), TAUCPR(LC),
     $                    OPRIM(LC), PMOM(1,LC), TEMPER(LC-1)
         IF( NOPLNK )
     $       WRITE( *,1200 )  LC, DTAUC(LC), TAUC(LC), SSALB(LC),
     $                    FLYR(LC), TAUCPR(LC)-TAUCPR(LC-1), TAUCPR(LC),
     $                    OPRIM(LC), PMOM(1,LC)
 10   CONTINUE
      IF( .NOT.NOPLNK )  WRITE( *,1210 ) TEMPER(NLYR)
C
      IF( PRTMOM .AND. YESSCT.GT.0.D0 )  THEN
         WRITE( *, '(/,A)' )  ' LAYER   PHASE FUNCTION MOMENTS'
         DO 20 LC = 1, NLYR
            IF( SSALB(LC).GT.0.D0 )
     $          WRITE( *,1300 )  LC, ( PMOM(K,LC), K = 0, NSTR )
 20      CONTINUE
      ENDIF
C
      RETURN
C
 1010 FORMAT ( /, ' NO. STREAMS =', I4,
     $     '     NO. COMPUTATIONAL LAYERS =', I4 )
 1030 FORMAT( I4,' USER OPTICAL DEPTHS :',10F10.4, /, (26X,10F10.4) )
 1040 FORMAT( I4,' User polar angles cosines:',10F9.5,/,(31X,10F9.5) )
 1060 FORMAT( '    INCIDENT BEAM WITH INTENSITY =', 1P,E11.3, ' AND',
     $     ' POLAR ANGLE COSINE = ', 0P,F8.5,
     $     /,'    PLUS ISOTROPIC INCIDENT INTENSITY =', 1P,E11.3 )
 1080 FORMAT( '    BOTTOM ALBEDO (LAMBERTIAN) =', 0P,F8.4 )
 1100 FORMAT( ' NO THERMAL EMISSION' )
 1110 FORMAT( '    THERMAL EMISSION IN WAVENUMBER INTERVAL :',
     $     2F14.4,/
     $     ,'    BOTTOM TEMPERATURE =',
     $     F10.2, '     TOP TEMPERATURE ='
     $     ,F10.2,'    TOP EMISSIVITY =', F8.4 )
 1111 FORMAT( ' Uses pseudo-spherical geometry' )
 1112 FORMAT( ' Uses spherical geometry' )
 1113 FORMAT( ' Uses planD-parallel geometry' )
 1120 FORMAT( ' USES DELTA-M METHOD' )
 1130 FORMAT( ' DOES NOT USE DELTA-M METHOD' )
 1140 FORMAT( ' CALCULATION WITH GENERAL SOURCE TERM' )
 1150 FORMAT( ' CALCULATE sfluxes AND INTENSITIES' )
 1170 FORMAT( ' SETS RADIATION = 0 BELOW ABSORPTION OPTICAL DEPTH 10' )
 1190 FORMAT( /, 37X, '<------------- DELTA-M --------------->', /,
     $ '                   TOTAL    SINGLE                           ',
     $     'TOTAL    SINGLE', /,
     $     '       OPTICAL   OPTICAL   SCATTER   TRUNCATED   ',
     $     'OPTICAL   OPTICAL   SCATTER    ASYMM', /,
     $     '         DEPTH     DEPTH    ALBEDO    FRACTION     ',
     $     'DEPTH     DEPTH    ALBEDO   FACTOR   TEMPERATURE' )
 1191 FORMAT( /, 37X, '<------------- DELTA-M --------------->', /,
     $'                   TOTAL    SINGLE                           ',
     $     'TOTAL    SINGLE', /,
     $     '       OPTICAL   OPTICAL   SCATTER   TRUNCATED   ',
     $     'OPTICAL   OPTICAL   SCATTER    ASYMM', /,
     $     '         DEPTH     DEPTH    ALBEDO    FRACTION     ',
     $     'DEPTH     DEPTH    ALBEDO   FACTOR' )
 1200 FORMAT( I4, 2F10.4, F10.5, F12.5, 2F10.4, F10.5, F9.4,F14.3 )
 1210 FORMAT( 85X, F14.3 )
 1300 FORMAT( I6, 10F11.6, /, (6X,10F11.6) )
C     
      END
*
      SUBROUTINE gsetbco(ch, cmu, lc, maxcmu, mxcmu, nstr, 
     $     xga, xg0, xg1, qsrc, taucpr, zj, zj0, zj1, zj2 )
C
C       SET COEFFICIENTS IN KS(7) FOR GENERAL SOURCE
C
C       INPUT : 
C                qsrc        GENERAL SOURCE
C
C       OUTPUT:  xga         ALFA IN EQ. KS(7) 
C                xg0         X-SUB-ZERO IN KS(7)
C                xg1         X-SUB-ONE IN KS(7)
C
C
C       Internal: lsc        Index of central internal source level
C                            There are nlyr layers, the source
C                            is also given at midlayers, 
C                            Hence 
C                                lst = 2*lc-1  top
C                                lsc = 2*lc    central
C                                lsb = 2*lc+1  bottom
C
C
C
      implicit double precision (A-H, O-Z)
      DOUBLE PRECISION d1mach
      real*8 big, biggest, cmu(*),
     $     q0, q2, taucpr(0:*), zj(*), zj0(*), zj1(*), zj2(*), 
     $     xga(*), xg0(mxcmu,*),
     $     xg1(mxcmu,*), qsrc(maxcmu, 0:*), ch(*)
      real*8 deltat, pi, q0a, q2a, sum, depsil
      integer nn, lsc, lsb, lst, iq
      logical debug

      debug = .false.

      pi = 2.D0 * DASIN(1.0D0)
      biggest  = d1mach(2)  
      big   = dsqrt(biggest) / 1.D+10
      depsil = 1000.D0 * d1mach(4) 

      lst = 2*lc+1 -1
      lsc = 2*lc   -1
      lsb = 2*lc-1 -1

*
*     Rearrange everything so that internal source agree with Disort
*     weird cmu angles, yac.....
*
      nn= nstr/2
      DO iq = 1, nn
         zj(iq)         = qsrc(nn+iq  , lst)
         zj(nn+iq)      = qsrc(nn+1-iq, lst)
      ENDDO
      DO iq = 1, nstr
         zj0(iq)        = zj(iq)
      ENDDO
      DO iq = 1, nn
         zj(iq)         = qsrc(nn+iq  , lsc)
         zj(nn+iq)      = qsrc(nn+1-iq, lsc)
      ENDDO
      DO iq = 1, nstr
         zj1(iq)        = zj(iq)
      ENDDO
      DO iq = 1, nn
         zj(iq)         = qsrc(nn+iq  , lsb)
         zj(nn+iq)      = qsrc(nn+1-iq, lsb)
      ENDDO
      DO iq = 1, nstr
         zj2(iq)        = zj(iq)
      ENDDO

      deltat = taucpr(lc) - taucpr(lc-1)

      xga( lc ) = 0.0D0

C                                  **   CHECK IF DELTAT .GT. THAN
C                                  **   SMAALEST NUMBER ALLOWED ON 
C                                  **   MACHINE, IF DEPSIL = 0.0 IS
C                                  **   USED, ARITHMETIC OVERFLOW
C                                  **   MAY BE THE RESULT LATER, SEE
C                                  **   EQ. FOR XGA(LC).
      IF ( deltat .GT. depsil ) THEN
C                                  * Pick an "arbitrary" angle
         iq = nn/2                 

         if ( debug ) 
     $        write(*,3458) lc, iq, zj0(iq), zj1(iq), zj2(iq)
 3458    FORMAT("zzzsrca", 2I3, 3E15.7 )

         IF ( abs(zj2(iq)) .GT. abs(zj0(iq))*1e-03 ) THEN
C                                                  EQ. KS(47)
C
            arg = (zj1(iq)/zj2(iq))**2.D0-zj0(iq)/zj2(iq)
            arg2 = (zj1(iq)/zj0(iq))**2.D0-zj2(iq)/zj0(iq)
         if ( debug ) 
     $           write(*,*)"zzzarg", lc, iq, arg, arg2, 
     $           zj0(iq), zj1(iq), zj2(iq)
            IF ( arg .LT. 0.0D0 ) arg = 0.0D0
C
C                                   **  USE PLUS (NEGATIVE) SOLUTION IF      
C                                   **  DE(IN)CREASING TEMPERATURE
C
            IF ( zj2(iq) .GT. zj0(iq) ) THEN
               xga(lc) = (2.D0/deltat) *DLOG((0.5*(zj0(iq)+zj1(iq))
     $              /zj2(iq))+DSQRT(arg))
               if ( debug ) 
     $              write(*,*)"zzzaa", lc, iq, arg, zj0(iq),
     $              zj1(iq),zj2(iq),xga(lc)     
            ELSE
               xga(lc) = (2.D0/deltat) *DLOG((0.5*(zj0(iq)+zj1(iq))
     $              /zj2(iq))-DSQRT(arg))
               if ( debug ) 
     $              write(*,*)"zzzbb", lc, iq, arg, zj0(iq),
     $              zj1(iq),zj2(iq),xga(lc)     
            ENDIF
         ELSE 
            IF (zj1(iq) .NE. 0.0D0 ) THEN
               xga(lc) = (1/(taucpr(lc)-taucpr(lc-1))) *
     $           DLOG(zj0(iq)/(2.D0*zj1(iq)))
               if ( debug ) 
     $              write(*,*)"zzzcc", lc, iq, arg, zj0(iq),
     $              zj1(iq),zj2(iq),xga(lc)     

            ENDIF
         ENDIF
C                                                  EQ. KS(48)
C
         if ( debug ) 
     $        write(*,*)"zzzxgat", lc, xga(LC),
     $        taucpr(lc),DLOG(d1mach(2)/100.D0)
         IF (DABS(xga(LC)*taucpr(lc)).GT.DLOG(d1mach(2)/100.D0)) THEN
            xga(lc) = 0.0D0
            if ( debug ) 
     $           write(*,*)"xgac", lc, xga(lc), taucpr(lc), 
     $           xga(LC)*taucpr(lc), DLOG(d1mach(2)/100.D0)
         ENDIF

*
*     Dither alfa if it is close to one of the quadrature angles
*
         IF (  DABS(xga(lc)) .gt. 0.00001d0 ) THEN
            DO IQ = 1, NSTR/2
               IF (DABS((DABS(xga(LC))-1.D0/CMU(IQ))/xga(lc) ) .LT. 
     $              0.05D0 )then
                  xga(LC) = xga(LC) * 1.001D0
               ENDIF	
            ENDDO
         ENDIF
         IF(DABS(xga(lc)).GT.big.AND.taucpr(lc).GT.1.D0)THEN
            xga(lc) = 0.0D0
            if ( debug ) 
     $           write(*,*)"xgaa", lc, xga(lc), big, taucpr(lc)
         ENDIF
         IF( DABS(xga(lc)*taucpr(lc)) .GT. DLOG(big))THEN
            xga(lc) = 0.0D0
            if ( debug ) 
     $           write(*,*)"xgab", lc, xga(lc), dlog(big), taucpr(lc)
         ENDIF	  

         DO iq = 1, nstr
            xg1(iq,lc)=(1.D0/deltat)*(zj2(iq)*DEXP(xga(lc)*taucpr(lc))
     $           -zj0(iq)*DEXP(xga(lc)*taucpr(lc-1)))
         ENDDO
      ELSE
         DO iq = 1, nstr
            xg1(iq, lc ) = 0.0D0
         ENDDO
      ENDIF

C                                                  EQ. KS(49)
C
C     Assume source is constant over the layer. Easiest and simplest and
C     it works. AKY 250909.
C
      DO iq = 1, nstr
         xga(lc) = 0.0D0
         xg0(iq, lc ) = zj0(iq)
         xg1(iq, lc ) = 0.0D0

         tau0 = taucpr(lc-1)
         src0 = dexp( -xga(lc)*tau0)*(xg0(iq, lc ) + xg1(iq,lc)*tau0)
         tau1 = (taucpr(lc-1)+taucpr(lc))/2
         src1 = dexp( -xga(lc)*tau1)*(xg0(iq, lc ) + xg1(iq,lc)*tau1)
         tau2 = taucpr(lc)
         src2 = dexp( -xga(lc)*tau2)*(xg0(iq, lc ) + xg1(iq,lc)*tau2)


         if ( debug ) 
     $        WRITE(*,3456) lc, iq, xga(lc), xg0(iq,lc), 
     $        xg1(iq,lc), taucpr(lc), zj0(iq), zj1(iq), zj2(iq)
 3456    FORMAT("zzzXGA", 2I3, 3E15.7, F13.7, 3E15.7 )
         if ( debug ) 
     $        WRITE(*,3457) lc, tau0, tau1, tau2, src0, src1, src2
         if ( debug ) 
     $        WRITE(*,3457) lc, tau0, tau1, tau2, src0, src1, src2
 3457    FORMAT("zzbsrc", I3, 3E15.7, "                ", 3E15.7 )
      ENDDO

      RETURN
      END
*
      SUBROUTINE dpqsetbco( ch, chtau, cmu, delm0, fbeam,
     $     gl, lc, maz, mxcmu, nstr, 
     $     taucpr,  xba, xb0, xb1,  
     $     zj, ylmc, ylm0)
C
C       SET COEFFICIENTS IN KS(7) FOR BEAM SOURCE
C
C       INPUT :  CMU         COMPUTATIONAL POLAR ANGLES
C                DELMO       KRONECKER DELTA, DELTA-SUB-M0
C                GL          PHASE FUNCTION LEGENDRE COEFFICIENTS MULTI-
C                              PLIED BY (2L+1) AND SINGLE-SCATTER ALBEDO
C                MAZ         ORDER OF AZIMUTHAL COMPONENT
C                TAUCPR      DELTA-M-SCALED OPTICAL DEPTH
C                YLMC        NORMALIZED ASSOCIATED LEGENDRE POLYNOMIAL
C                            AT THE QUADRATURE ANGLES -CMU-
C                YLM0        NORMALIZED ASSOCIATED LEGENDRE POLYNOMIAL
C                            AT THE BEAM ANGLE
C
C       OUTPUT:  xba         ALFA IN EQ. KS(7) 
C                xb0         X-SUB-ZERO IN KS(7)
C                xb1         X-SUB-ONE IN KS(7)
C
C
      implicit double precision (A-H, O-Z)
      DOUBLE PRECISION d1mach
      real*8 big, biggest, ch(*), chtau(0:*), cmu(*),
     $     delm0, fbeam, gl(0:mxcmu,*), q0, q2, 
     $     taucpr(0:*),  xba(*), xb0(mxcmu,*),
     $     xb1(mxcmu,*), zj(*), ylmc(0:mxcmu,*), ylm0(0:*)
      real*8 deltat, pi, q0a, 
     $     q2a, sum


      pi = 2.D0 * DASIN(1.0D0)
      biggest  = d1mach(2)  
      big   = dsqrt(biggest) / 1.D+10
*
*     Calculate x-sub-zero in STWJ(6d) 
*
      iqsav = 1
      DO 100 IQ = 1, NSTR
         SUM = 0.D0
         DO 110 K = MAZ, NSTR-1
            SUM = SUM + GL(K,LC)*YLMC(K,IQ)*YLM0(K)
 110     CONTINUE
         ZJ(IQ) = (2.D0-DELM0)*FBEAM*SUM / (4.D0*PI)
         IF ( zj(iq) .GT. zj(iqsav) ) iqsav = iq
 100  CONTINUE
*     
      q0a = DEXP( -chtau(lc-1) )
      q2a = DEXP( -chtau(lc) )
*     
*     Calculate alfa coefficient for one fixed angle
*     
      q0 = q0a*zj(iqsav)
      q2 = q2a*zj(iqsav)
  
      deltat = taucpr(lc) - taucpr(lc-1)
     
      xba(lc) = 1.D0/ch(lc)
        
      IF(DABS(xba(lc)).GT.big.AND.taucpr(lc).GT.1.D0)THEN
         xba(lc) = 0.0D0
      ENDIF
      IF( DABS(xba(lc)*taucpr(lc)) .GT. DLOG(big))THEN
	  xba(lc) = 0.0D0
      ENDIF	  
*
*     Dither alfa if it is close to one of the quadrature angles
*
      IF (  DABS(xba(lc)) .gt. 0.00001d0 ) THEN
         DO IQ = 1, NSTR/2
            IF (DABS((DABS(xba(LC))-1.D0/CMU(IQ))/xba(lc) ) .LT. 
     $           0.05D0 )then
C                  0.05                  001             
                xba(LC) = xba(LC) * 1.001D0

	    ENDIF	
         ENDDO
      ENDIF
      DO iq = 1, nstr
         q0 = q0a * zj(iq)
         q2 = q2a * zj(iq)
*     
*     x-sub-zero and x-sub-one in Eqs. KS(48-49)
*     
       
         xb1(iq,lc) = (1.D0/deltat)*(q2*DEXP(xba(lc)*taucpr(lc))
     $                     -q0*DEXP(xba(lc)*taucpr(lc-1)))
    
	                                       
         xb0(iq,lc) = q0 * DEXP(xba(lc)*taucpr(lc-1))-
     $        xb1(iq,lc)*taucpr(lc-1)
        

    
      ENDDO
     
*     
      RETURN
      END
*
      SUBROUTINE dpqintbco( qsrcu, lc, maz, maxumu, mxumu, numu,
     $     taucpr, zg0u, zg1u, xga )
*
      implicit double precision (A-H, O-Z)
      real*8  qsrcu(maxumu, 0:*), q0, q2, taucpr(0:*), xga(*), 
     $     zg0u(mxumu,*), zg1u(mxumu,*), deltat
      integer lsb, lsc, lst
*
*     Find coefficients at user angle, necessary for later use in
*     *sterpso*
*     

      lst = 2*lc+1 -1
      lsc = 2*lc   -1
      lsb = 2*lc-1 -1

      deltat = taucpr(lc) - taucpr(lc-1)
      DO iu = 1, numu
         q0 = qsrcu(iu,lst)
         q2 = qsrcu(iu,lsb)
*     
*     x-sub-zero and x-sub-one in Eqs. KS(48-49)
*

         zg1u(iu,lc)=(1.d0/deltat)*(q2*DEXP(xga(lc)*taucpr(lc))
     $        -q0*DEXP(xga(lc)*taucpr(lc-1)))
         zg0u(iu,lc) = q0 * DEXP(xga(lc)*taucpr(lc-1))-
     $        zg1u(iu,lc)*taucpr(lc-1)
         
      ENDDO      
*     
      RETURN
      END
*
      SUBROUTINE  dpqsetdis
     $     ( ICHAP,acmu, albedo, bdr, beta, bplank, btemp, ch,
     $     chtau, cmu, cwt, deltam, deltamu, dtauc,EXPbea, fbeam, 
     $     flyr, gl, gsrc, layru, layru_c, lyrcut, maxumu, maxcmu,
     $     ncut, 
     $     newgeo, nlyr, ntau, ntau_c, nn, nstr, noplnk, numu,
     $     onlyfl, oprim, pkag, pkagc, pmom, radius, spher, ssalb,
     $     tauc, taucpr, temis, temper, tplank, ttemp, utau,
     $     utau_c, utaupr, utaupr_c, umu0, umu, usrtau,
     $     usrang,  wvnmlo, 
     $     wvnmhi, zd, numu_c, umu_c, numu_u, umu_u,
     $     BROSZA,SIGBRO,DENSBRO, dtauc_mb,
     $     sza_bro, ndenssza, VN, nrefrac)
*
*     Modified from original disort setdis routine to do various setup
*     operations required by the spherical version of disort.
*
C
C          PERFORM MISCELLANEOUS SETTING-UP operations
C
C       ROUTINES CALLED:  ERRMSG, sqgausn, dpszeroit
C
C       INPUT :  ALL ARE 'DISORT' INPUT VARIABLES (SEE DOC FILE)
C                BROSZA: if =1, BrO density is a function of SZA 
C
C       OUTPUT:  NTAU,UTAU   IF USRTAU = FALSE
C                CMU,CWT     COMPUTATIONAL POLAR ANGLES AND
C                               CORRESPONDING QUADRATURE WEIGHTS
C                EXPBEA      TRANSMISSION OF DIRECT BEAM
C                FLYR        TRUNCATED FRACTION IN DELTA-M METHOD
C                GL          PHASE FUNCTION LEGENDRE COEFFICIENTS MULTI-
C                              PLIED BY (2L+1) AND SINGLE-SCATTER ALBEDO
C                LAYRU       COMPUTATIONAL LAYER IN WHICH -UTAU- FALLS
C                LYRCUT      FLAG AS TO WHETHER RADIATION WILL BE ZEROED
C                              BELOW LAYER -NCUT-
C                NCUT        COMPUTATIONAL LAYER WHERE ABSORPTION
C                              OPTICAL DEPTH FIRST EXCEEDS -ABSCUT-
C                NN          NSTR / 2
C                OPRIM       DELTA-M-SCALED SINGLE-SCATTER ALBEDO
C                TAUCPR      DELTA-M-SCALED OPTICAL DEPTH
C                UMU         OUTPUT ANGLES, EQUAL TO THE 
C                            COMPUTATIONAL POLAR ANGLES, BUT SORTED
C                            IN ASCENDING ORDER
C                UTAUPR      DELTA-M-SCALED VERSION OF -UTAU-
C
C      INTERNAL VARIABLES
C                TEMPC       TEMPERATURE AT CENTER OF LAYER, ASSUMED
C                            TO BE AVERAGE OF LAYER BOUNDARY TEMPERATURES
C
      INTEGER MXCLY, MXULV, MXCMU, MXUMU, MXPHI,
     $        MI, MI9M2, NNLYRI 
      INCLUDE "DISORT.MXD"
      PARAMETER ( MI = MXCMU/2, MI9M2 = 9*MI-2,
     $     NNLYRI = MXCMU*MXCLY )

      external chpman2
      LOGICAL  DELTAM, LYRCUT, newgeo, NOPLNK, onlyfl, SPHER, usrang,
     $     USRTAU, gsrc
      INTEGER  layru(*),  layru_c(*), ntau_c, BROSZA
      real*8 acmu(*), albedo, bdr( mi,0:* ), beta(0:*),
     $     bplank, btemp, ch(*), chtau(0:*), cmu(*), cwt(*), dtauc(*),
     $     EXPbea(0:*), fbeam, flyr(*), gl(0:mxcmu,*),
     $     oprim(*), pkag(0:*), pkagc(*), pmom(0:maxcmu,*), radius,
     $     ssalb(*), tauc(0:*), taucpr(0:*), taup, tempc, 
     $     temis, temper(0:*), tplank, ttemp, umu(*), umu0,
     $     utau(*), utau_c(*), utaupr(*),
     $     utaupr_c(*), wvnmhi, wvnmlo,SIGBRO(0:*),
     $     DENSBRO(mxsza,0:*),dtauc_mb(*),sza_bro(mxsza)

      INTEGER numu_c, numu_u
      real*8 umu_c(*), umu_u(*)
      real*8 abstau, deltamu, f, pi
      real*8 dpsplkavg
      real*8 dtaucpr(mxcly)
*      
      real*8 CHP1(mxcly),CHP2(mxcly),vdbr(mxcly)
      real*8 
     $       DTAUBRO_1(mxcly,mxcly),DTAUBRO_2(mxcly,mxcly),
     $       DBRO(mxcly,0:mxcly),
     $       DBRO_2(mxcly,0:mxcly)
*      real*8 
*     $       DTAUBRO_1(nlyr,nlyr),DTAUBRO_2(nlyr,nlyr),
*     $       DBRO(nlyr,0:nlyr),
*     $       DBRO_2(nlyr,0:nlyr)
     
 
*     inputs and outputs of geofac     
 
      integer NFAC_11(mxcly), NFAC_12(mxcly)
      real*8  fac_11(mxcly,mxcly), fac_12(mxcly,mxcly)
      integer NFAC_21(mxcly), NFAC_22(mxcly)
      real*8  fac_21(mxcly,mxcly), fac_22(mxcly,mxcly)
      
      real*8  SZALOC_1(mxcly,0:mxcly), 
     $        SZALOC_2(mxcly,0:mxcly)
      
*
      real*8  z_lay, zd(0:mxcly), zenang, rearth,
     $        VN(0:mxcly)
     
* 
*     save geometric factors (no dependent on wavelength)
      SAVE nfac_11,nfac_12,fac_11,fac_12
      SAVE nfac_21,nfac_22,fac_21,fac_22
*     
      DATA  ABSCUT / 400.D0 /
      rearth=radius
           
      PI = 2.D0 * DASIN( 1.D0 )

      CALL  dpszeroit( BDR, MI*(MI+1) )

    
      NN = NSTR / 2
      DO 20 IQ = 1, NN
         DO 20 JQ = 0, NN
            BDR(IQ,JQ) = ALBEDO
20    CONTINUE
C
*
*     Set usrtau to include every level when doing the spherical
*     correction.
*
      ntau_c = nlyr + 1
      DO  lc = 0, ntau_c-1
         utau_c(lc+1) = tauc(lc)
      ENDDO
*
      IF ( .NOT.USRTAU ) THEN
C                              ** SET OUTPUT LEVELS AT COMPUTATIONAL
C                              ** LAYER BOUNDARIES
         NTAU = NLYR + 1
         DO 30  LC = 0, NTAU-1
            UTAU(LC+1) = TAUC(LC)
30       CONTINUE
      END IF
C
C                        ** APPLY DELTA-M SCALING AND MOVE DESCRIPTION
C                        ** OF COMPUTATIONAL LAYERS TO LOCAL VARIABLES

      CALL  dpszeroit( TAUCPR(0), MXCLY+1 )
      CALL  dpszeroit( EXPBEA(0), MXCLY+1 )
      CALL  dpszeroit( FLYR, MXCLY )
      CALL  dpszeroit( GL, (MXCMU+1)*MXCLY )
      CALL  dpszeroit( OPRIM, MXCLY )
      ABSTAU = 0.0D0
      chtau(0) = 0.0D0
*
      DO  60  LC = 1, NLYR
      
         PMOM(0,LC) = 1.D0
         IF ( ABSTAU.LT.ABSCUT )  NCUT = LC
         ABSTAU = ABSTAU + ( 1.D0 - SSALB(LC) ) * DTAUC(LC)
C     
         IF ( .NOT.DELTAM )  THEN
            OPRIM(LC) = SSALB(LC)
            TAUCPR(LC) = TAUC(LC)
            DO 40  K = 0, NSTR-1
               GL(K,LC) = (2*K+1) * OPRIM(LC) * PMOM(K,LC)
 40         CONTINUE
            dtaucpr(lc)= dtauc(lc)
            F = 0.0D0
         ELSE
C                             ** DO DELTA-M TRANSFORMATION
            F = PMOM( NSTR,LC )
            beta(lc)  = beta(lc) * ( 1.D0 - f * ssalb(lc) )
            OPRIM(LC) = SSALB(LC) * ( 1.D0 - F ) /
     $           ( 1.D0 - F * SSALB(LC) )
            TAUCPR(LC) = TAUCPR(LC-1) +
     $           ( 1. - F*SSALB(LC) ) * DTAUC(LC)
            DO 50  K = 0, NSTR-1
               GL(K,LC) = (2*K+1) * OPRIM(LC) *
     $              (PMOM(K,LC)-F) / (1.D0-F)
 50         CONTINUE
            dtaucpr(lc)= taucpr(lc) - taucpr(lc-1)
	   
         ENDIF
         FLYR(LC) = F
 60   CONTINUE
 
   
*
      IF (BROSZA.EQ.0) THEN      
*           
         IF ( fbeam .GT. 0.D0 .or. gsrc ) THEN
*
            zenang      = DACOS(umu0) * 180.D0/pi
            IF ( spher ) THEN
*	   
               IF(NEWGEO)THEN
*     GEOMETRIC FACTORS	     
                  z_lay = 0.0D0
              
	
                  if(nrefrac.lt.2)then
*     Refraction with fast method (or no refraction at all)	      
                     CALL geofast
     $                    (brosza,sza_bro, fac_11,nfac_11,szaloc_1,
     $                    fac_12,nfac_12,szaloc_2,
     $                    z_lay,nlyr,zd,zenang,rearth,VN)
                  else
*     Refraction with slow (more precise) method	      
                     CALL geofacpr
     $                    (brosza,sza_bro, fac_11,nfac_11,
     $                    szaloc_1, fac_12,nfac_12,szaloc_2,
     $                    z_lay,nlyr,zd,zenang,rearth,VN)
                  endif
                  rearth=rearth*1.D-5
               ENDIF
*     
*     CHAPMAN FACTORS 
               call chpman2(nlyr,zenang,dtaucpr,nfac_11,fac_11,
     $              nfac_12,fac_12,chp1, mxcly)
     
               IF(NEWGEO)THEN
*     GEOMETRIC FACTORS	 	     

                  z_lay = 0.5D0

                  if(nrefrac.lt.2)then
                     CALL geofast
     $                    (brosza,sza_bro, fac_21,nfac_21,szaloc_1,
     $                    fac_22,nfac_22,szaloc_2,
     $                    z_lay,nlyr,zd,zenang,rearth,VN)
                  else
*     Refraction with slow (more precise) method	      
                     CALL geofacpr
     $                    (brosza,sza_bro, fac_21,nfac_21,
     $                    szaloc_1, fac_22,nfac_22,szaloc_2,
     $                    z_lay,nlyr,zd,zenang,rearth,VN)
                  endif
               ENDIF
*     CHAPMAN FACTORS	      
               call chpman2(nlyr,zenang,dtauc,nfac_21,fac_21,
     $              nfac_22,fac_22,chp2,mxcly)

               EXPbea( 0 ) = 1.D0
               IF( umu0 .LT. 0.D0 ) THEN	     
                  EXPbea(0) =DEXP(-chp1(1))
               ENDIF
*
               DO lc = 1, ncut
                  taup       = tauc(lc-1) + dtauc(lc)/2.D0
                  chtau(lc)=chp1(lc)  
                  ch(lc)     = taup/chp2(lc)
                  EXPbea(lc) = DEXP(-chp1(lc))
               ENDDO
            ENDIF 
            
            IF( ICHAP .EQ. 0 ) THEN
               
*             ********************************************************	   
*             PSEUDO SPHERICAL model - CHAPMAN = PLANE PARALLEL model!
*             ********************************************************

               DO lc = 1, ncut            
                  ch(lc) = umu0
                  chtau(lc)= taucpr(lc) / umu0 
                  EXPbea(lc) = DEXP( - taucpr(lc) / umu0 )
               ENDDO
            ENDIF
*     
         ENDIF
*     
      ELSE
*        
*     BrO density is function of altitude and local SZA

         zenang      = DACOS(umu0) * 180.D0/pi
	
*     
         IF ( spher ) THEN
*	
            IF(newgeo) then	
               z_lay = 0.0D0
               
               if(nrefrac.eq.2)then
                  CALL geofacpr(brosza,sza_bro, fac_11,nfac_11,
     $                 szaloc_1, fac_12,nfac_12,szaloc_2,
     $                 z_lay,nlyr,zd,zenang,rearth,VN)
               else
                  CALL geofast(brosza,sza_bro, fac_11,nfac_11,
     $                 szaloc_1,fac_12,nfac_12,szaloc_2,
     $                 z_lay,nlyr,zd,zenang,rearth,VN)
               endif
               rearth=rearth*1.D-5
            ENDIF

            CALL dtbro(zd,zenang,sigbro,densbro,sza_bro,
     $           NFAC_11, NFAC_12,
     $           SZALOC_1, SZALOC_2, 
     $           nlyr, ndenssza,
     $           DTAUBRO_1, DTAUBRO_2,DBRO,DBRO_2,
     $           vdbr)
            
            CALL chapman4(NLYR,zenang,
     $           NFAC_11,FAC_11,DTAUC_MB,DTAUBRO_1,
     $           NFAC_12,FAC_12,DTAUBRO_2, mxcly,
     $           CHP1)
            
*	     
            IF(newgeo) then	     
*	     
               z_lay = 0.5D0
	     
               if(nrefrac.eq.2)then
                  CALL geofacpr
     $                 (brosza,sza_bro, fac_21,nfac_21,szaloc_1,
     $                 fac_22,nfac_22,szaloc_2,
     $                 z_lay,nlyr,zd,zenang,rearth,VN)
               else
                  CALL geofast
     $                 (brosza,sza_bro,fac_21,nfac_21,szaloc_1,
     $                 fac_22,nfac_22,szaloc_2,
     $                 z_lay,nlyr,zd,zenang,rearth,VN)
               endif
               
            ENDIF    
               
            CALL dtbro(zd,zenang,sigbro,densbro,sza_bro,
     $           nfac_21, nfac_22,
     $           szaloc_1, szaloc_2, 
     $           nlyr, ndenssza,
     $           dtaubro_1,dtaubro_2,DBRO,dbro_2,
     $           vdbr)
            
            
            CALL chapman4(NLYR,zenang,
     $           nfac_21,fac_21,DTAUC_MB,dtaubro_1,
     $           nfac_22,fac_22,dtaubro_2, mxcly,
     $           CHP2)
            
            
            EXPbea( 0 ) = 1.D0
            IF( umu0 .LT. 0.D0 ) THEN	     
               EXPbea(0) = DEXP(-CHP1(1))
            ENDIF
*     
            
            DO lc = 1, nlyr
               
               taup = taucpr(lc-1) + dtaucpr(lc)*0.5d0                      
               chtau(lc)  = CHP1(lc) 
               ch(lc)     = taup/CHP2(lc)
               EXPbea(lc) = DEXP(-CHP1(lc))
               
            ENDDO 
            
            IF( ICHAP .EQ. 0 ) THEN
               
*     ********************************************************	   
*     PSEUDO SPHERICAL model - CHAPMAN = PLANE PARALLEL model!
*     ********************************************************
               
               DO lc = 1, ncut            
                  ch(lc) = umu0
                  chtau(lc)= taucpr(lc) / umu0 
                  EXPbea(lc) = DEXP( - taucpr(lc) / umu0 )
               ENDDO
            ENDIF 
         ENDIF 
         
      ENDIF      
         
     
*

C                      ** IF NO THERMAL EMISSION, CUT OFF MEDIUM BELOW
C                      ** ABSORPTION OPTICAL DEPTH = ABSCUT ( NOTE THAT
C                      ** DELTA-M TRANSFORMATION LEAVES ABSORPTION
C                      ** OPTICAL DEPTH INVARIANT ).  NOT WORTH THE
C                      ** TROUBLE FOR ONE-LAYER PROBLEMS, THOUGH.
      LYRCUT = .false.
      IF ( ABSTAU.GE.ABSCUT .AND. NOPLNK
     $     .AND. NLYR.GT.1 )  LYRCUT =.TRUE.
      IF ( .NOT.LYRCUT )  NCUT = NLYR
C
C                             ** SET ARRAYS DEFINING LOCATION OF USER
C                             ** OUTPUT LEVELS WITHIN DELTA-M-SCALED
C                             ** COMPUTATIONAL MESH
      DO 90  LU = 1, NTAU
         DO 70 LC = 1, NLYR
            IF ( UTAU(LU).GE.TAUC(LC-1) .AND. UTAU(LU).LE.TAUC(LC) )
     $           GO TO 80
70       CONTINUE
         LC = NLYR

80       UTAUPR(LU) = UTAU(LU)
         IF(DELTAM) UTAUPR(LU) = TAUCPR(LC-1) +
     $        (1.-SSALB(LC)*FLYR(LC)) * (UTAU(LU) - TAUC(LC-1))
         LAYRU(LU) = LC
90    CONTINUE
*
      DO lu = 1, ntau_c
         DO lc = 1, nlyr
            IF ( utau_c(lu).GE.tauc(lc-1) .AND. utau_c(lu).LE.tauc(lc) )
     $           GO TO 88
         ENDDO
         lc = nlyr
*
 88      utaupr_c(lu) = utau_c(lu)
         IF ( deltam ) utaupr_c(lu) = taucpr(lc-1) +
     $        (1.-ssalb(lc)*flyr(lc)) * (utau_c(lu) - tauc(lc-1))
         layru_c(lu) = lc
      ENDDO
*
C                      ** CALCULATE COMPUTATIONAL POLAR ANGLE COSINES
C                      ** AND ASSOCIATED QUADRATURE WEIGHTS FOR GAUSSIAN
C                      ** QUADRATURE ON THE INTERVAL (0,1) (UPWARD)
      CALL  dpsqgausn( NN, CMU, CWT )
C                                  ** DOWNWARD (NEG) ANGLES AND WEIGHTS
      DO 100  IQ = 1, NN
         CMU(IQ+NN) = - CMU(IQ)
         CWT(IQ+NN) =   CWT(IQ)
100   CONTINUE
      
   
*
* Set computational angles at where derivatives are needed.
*
      DO iq = 1, nn
         acmu(iq) = - cmu(nn+1-iq)
      ENDDO
      DO iq = nn+1, nstr
         acmu(iq) = cmu(iq-nn)
      ENDDO
*
      numu_c   =  2*nstr
      deltamu  =  0.001D0
      jq       =  1
*
      DO iq = 1, 2*nstr, 2   ! Next all derivative angles
         umu_c(iq)   = acmu(jq) - deltamu
         umu_c(iq+1) = acmu(jq) + deltamu
         jq         = jq + 1
      ENDDO
*
* Set user angles at where derivatives are needed.
*
      IF ( usrang ) THEN
         numu_u   =  2*numu
         deltamu  =  0.001D0
         ju       =  1
*
         DO iu = 1, numu_u, 2   ! Next all derivative angles
            umu_u(iu)   = umu(ju) - deltamu
            umu_u(iu+1) = umu(ju) + deltamu
            IF ( umu_u(iu) .LT. -1.D0 ) THEN
               umu_u(iu) = -1.D0
               umu_u(iu+1) = -1.D0 + 2.0D0*deltamu
            ENDIF
            IF ( umu_u(iu+1) .GT. 1.D0 ) THEN
               umu_u(iu+1) = 1.D0
               umu_u(iu) = 1.D0 - 2.D0*deltamu
            ENDIF
            ju         = ju + 1
         ENDDO
      ENDIF
*
      IF ( .NOT.usrang .OR. (onlyfl .AND. maxumu.GE.nstr )) THEN
*
*                                   ** SET OUTPUT POLAR ANGLES TO
*                                   ** COMPUTATIONAL POLAR ANGLES
         numu = nstr 
         DO 120  IU = 1, NN
            UMU(IU) = - CMU(NN+1-IU)
 120     CONTINUE
         DO 121  IU = NN+1, NSTR
            UMU(IU) = CMU(IU-NN)
 121     CONTINUE
      ENDIF 
      
C
C
C                                   ** CALCULATE PLANCK FUNCTIONS
      IF ( NOPLNK )  THEN
         BPLANK = 0.0D0
         TPLANK = 0.0D0
         CALL  dpszeroit( PKAG, MXCLY+1 )
         CALL  dpszeroit( PKAGC, MXCLY )
      ELSE
         TPLANK = TEMIS * dpsplkavg( WVNMLO, WVNMHI, TTEMP )
         BPLANK =         dpsplkavg( WVNMLO, WVNMHI, BTEMP )
         DO 180  LEV = 0, NLYR
            PKAG( LEV ) = dpsplkavg( WVNMLO, WVNMHI, TEMPER(LEV) )
180      CONTINUE
         DO 190 LC = 1, NLYR
            TEMPC = 0.5D0 * ( TEMPER(LC-1) + TEMPER(LC) )
            PKAGC( LC ) = dpsplkavg( WVNMLO, WVNMHI, TEMPC )
190      CONTINUE
      END IF
C
      RETURN
      END
*
*
      SUBROUTINE  dpqsolve0( ALBEDO, B, BPLANK, CBAND, CMU, CWT, 
     $     EXPBEA, FBEAM, FISOT, il, IPVT, LL, LYRCUT,
     $     MAZ, MI, MI9M2, MXCMU, NCOL, NCUT, NN, noplnk, NSTR,
     $     NNLYRI, PI, TPLANK, TAUCPR, UMU0, Z, ZBEAM0,
     $     ZBEAM1, ZBEAMA, ZPLK0, ZPLK1, ZPLKA, ZGEN0,
     $     ZGEN1, ZGENA, gsrc, prnt )
C
C        CONSTRUCT RIGHT-HAND SIDE VECTOR -B- FOR GENERAL BOUNDARY
C        CONDITIONS STWJ(17) AND SOLVE SYSTEM OF EQUATIONS OBTAINED
C        FROM THE BOUNDARY CONDITIONS AND THE
C        CONTINUITY-OF-INTENSITY-AT-LAYER-INTERFACE EQUATIONS.
C        THERMAL EMISSION CONTRIBUTES ONLY IN AZIMUTHAL INDEPENDENCE.
C
C     ROUTINES CALLED:  SGBCO, SGBSL, dpszeroit
C
C     I N P U T      V A R I A B L E S:
C
C       BPLANK   :  BOTTOM BOUNDARY THERMAL EMISSION
C       CBAND    :  LEFT-HAND SIDE MATRIX OF LINEAR SYSTEM EQ. SC(5),
C                   SCALED BY EQ. SC(12); IN BANDED FORM REQUIRED
C                   BY LINPACK SOLUTION ROUTINES
C       CMU      :  ABSCISSAE FOR GAUSS QUADRATURE OVER ANGLE COSINE
C       CWT      :  WEIGHTS FOR GAUSS QUADRATURE OVER ANGLE COSINE
C       EXPBEA   :  TRANSMISSION OF INCIDENT BEAM,DEXP(-TAUCPR/UMU0)
*       il       :  iteration index
C       LYRCUT   :  LOGICAL FLAG FOR TRUNCATION OF COMPUT. LAYER
C       MAZ      :  ORDER OF AZIMUTHAL COMPONENT
C       NCOL     :  COUNTS OF COLUMNS IN -CBAND-
C       NN       :  ORDER OF DOUBLD-GAUSS QUADRATURE (NSTR/2)
C       NCUT     :  TOTAL NUMBER OF COMPUTATIONAL LAYERS CONSIDERED
C       TPLANK   :  TOP BOUNDARY THERMAL EMISSION
C       TAUCPR   :  CUMULATIVE OPTICAL DEPTH (DELTA-M-SCALED)
C       ZBEAMA   :  BEAM SOURCE COEFFICIENT ALFA IN EQ.KS(6)
C       ZBEAM0   :  BEAM SOURCE VECTORS Y-SUB-ZERO IN EQ.KS(6)
C       ZBEAM1   :  BEAM SOURCE VECTORS Y-SUB-ONE IN EQ.KS(6)
C       ZGENA    :  GENERAL SOURCE COEFFICIENT ALFA IN EQ.KS(6)
C       ZGEN0    :  GENERAL SOURCE VECTORS Y-SUB-ZERO IN EQ.KS(6)
C       ZGEN1    :  GENERAL SOURCE VECTORS Y-SUB-ONE IN EQ.KS(6)
C       ZPLK0    :  THERMAL SOURCE VECTORS -Z0-, BY SOLVING EQ. FS(5)
C       ZPLK1    :  THERMAL SOURCE VECTORS -Z1-, BY SOLVING EQ. FS(5)
C       ZPLKA    :  THERMAL SOURCE COEFFICIENT -ZA-, 
C                   ALFA IN EQ. FS(5)
C       (REMAINDER ARE 'DISORT' INPUT VARIABLES)
C
C   O U T P U T     V A R I A B L E S:
C
C       B        :  RIGHT-HAND SIDE VECTOR OF EQ. SC(5) GOING INTO
C                   *SGBSL*; RETURNS AS SOLUTION VECTOR OF EQ.
C                   SC(12), CONSTANTS OF INTEGsratioN WITHOUT
C                   EXPONENTIAL TERM
C      LL        :  PERMANENT STORAGE FOR -B-, BUT RD-ORDERED
C
C   I N T E R N A L    V A R I A B L E S:
C
C       IPVT     :  INTEGER VECTOR OF PIVOT INDICES
C       IT       :  POINTER FOR POSITION IN  -B-
C       NCD      :  NUMBER OF DIAGONALS BELOW OR ABOVE MAIN DIAGONAL
C       RCOND    :  INDICATOR OF SINGULARITY FOR -CBAND-
C       Z        :  SCRATCH ARRAY REQUIRED BY *SGBCO*
C+---------------------------------------------------------------------+
C
      implicit double precision (A-H, O-Z)
      LOGICAL  LYRCUT, noplnk, gsrc, prnt(*)
      INTEGER  IPVT(*)
      real*8 albedo, B(*), bplank,
     $     CBAND( MI9M2,NNLYRI ),
     $     CMU(*), CWT(*),EXPBEA(0:*), fbeam, fisot, LL( MXCMU,* ),
     $     pi, TAUCPR( 0:* ), tplank, umu0, Z(*), ZPLK0( MXCMU,* ),
     $     ZPLK1( MXCMU,* ), ZPLKA( * ), ZBEAM0( MXCMU,* ),
     $     ZBEAM1( MXCMU,* ), ZBEAMA( * ), ZGEN0( MXCMU,* ),
     $     ZGEN1( MXCMU,* ), ZGENA( * )
      real*8 rcond, sum
C
C
      CALL  dpszeroit( B, NNLYRI )
      IF ( pi .eq. 0.0D0 ) pi = 2.D0 * DASIN(1.D0)
*
C                             ** CONSTRUCT -B-,  STWJ(20A,C) FOR
C                             ** PARALLEL BEAM + BOTTOM REFLECTION +
C                             ** THERMAL EMISSION AT TOP AND/OR BOTTOM
C
      IF ( MAZ.GT.0 .AND. ( FBEAM.GT.0.0 .OR. gsrc) )  THEN
C
C                                         ** AZIMUTH-DEPENDENT CASE
C                                         ** (NEVER CALLED IF FBEAM = 0)
C               ** NO AZIMUTHAL-DEPENDENT INTENSITY FOR LAMBERT SURFACE;
C               ** NO INTENSITY COMPONENT FOR TRUNCATED BOTTOM LAYER
C
            DO 10  IQ = 1, NN
C                                                     ** TOP BOUNDARY
               B(IQ) = - ZBEAM0(NN+1-IQ,1) - ZGEN0(NN+1-IQ,1)
C                                                     ** BOTTOM BOUNDARY
               B(NCOL-NN+IQ) = -DEXP(-ZBEAMA(NCUT)*TAUCPR(NCUT))*
     $              (ZBEAM0(IQ+NN,NCUT)+
     $              ZBEAM1(IQ+NN,NCUT)*TAUCPR(NCUT))
     $              -DEXP(-ZGENA(NCUT)*TAUCPR(NCUT))*
     $              (ZGEN0(IQ+NN,NCUT)+
     $              ZGEN1(IQ+NN,NCUT)*TAUCPR(NCUT))

10          CONTINUE
C
C                             ** CONTINUITY CONDITION FOR LAYER
C                             ** INTERFACES OF EQ. STWJ(20B)
         IT = NN
         DO 40  LC = 1, NCUT-1
            DO 30  IQ = 1, NSTR
               IT    = IT + 1
               B(IT) =
     $              + DEXP(-ZBEAMA(LC+1)*TAUCPR(LC))*
     $              (ZBEAM0(IQ,LC+1)+ZBEAM1(IQ,LC+1)*TAUCPR(LC))
     $              -  DEXP(-ZBEAMA(LC)*TAUCPR(LC))*
     $              (ZBEAM0(IQ,LC)+ZBEAM1(IQ,LC)*TAUCPR(LC))
     $              + DEXP(-ZGENA(LC+1)*TAUCPR(LC))*
     $              (ZGEN0(IQ,LC+1)+ZGEN1(IQ,LC+1)*TAUCPR(LC))
     $              -  DEXP(-ZGENA(LC)*TAUCPR(LC))*
     $              (ZGEN0(IQ,LC)+ZGEN1(IQ,LC)*TAUCPR(LC))
               

 30         CONTINUE
 40      CONTINUE
C
C                                   ** AZIMUTH-INDEPENDENT CASE
*
      ELSE IF ( FBEAM.EQ.0.0 .AND. il .EQ. 0 .AND. .NOT. gsrc)   THEN
C
         DO 50 IQ = 1, NN
C                                      ** TOP BOUNDARY
C
            B(IQ) = - ZPLK0(NN+1-IQ,1) + FISOT + TPLANK
 50      CONTINUE
C
         IF ( LYRCUT ) THEN
C                               ** NO INTENSITY COMPONENT FOR TRUNCATED
C                               ** BOTTOM LAYER
            DO 60 IQ = 1, NN
C                                      ** BOTTOM BOUNDARY
C
               B(NCOL-NN+IQ) = 
     $              -  DEXP(-ZPLKA(NCUT)*TAUCPR(NCUT))*
     $              (ZPLK0(IQ+NN,NCUT)+ZPLK1(IQ+NN,NCUT)*TAUCPR(NCUT))
         
 60            continue
C
         ELSE
C
            DO 80 IQ = 1, NN
C
               SUM = 0.D0
               DO 70 JQ = 1, NN
                  SUM = SUM + CWT(JQ) * CMU(JQ) * ALBEDO
     $                 *(DEXP(-ZPLKA(NCUT)*TAUCPR(NCUT))*
     $                 (ZPLK0(NN+1-JQ,NCUT)+ZPLK1(NN+1-JQ,NCUT)
     $                 *TAUCPR(NCUT)))
 70            CONTINUE
               B(NCOL-NN+IQ) = 2.*SUM + (1.-ALBEDO) * BPLANK
     $              - DEXP(-ZPLKA(NCUT)*TAUCPR(NCUT))*
     $              (ZPLK0(IQ+NN,NCUT)+ZPLK1(IQ+NN,NCUT)*TAUCPR(NCUT))
            
 80         CONTINUE
         END IF
C                             ** CONTINUITY CONDITION FOR LAYER
C                             ** INTERFACES, STWJ(20B)
         IT = NN
         DO 100  LC = 1, NCUT-1
            DO 90  IQ = 1, NSTR
               IT    = IT + 1
               B(IT) =
     $              +  DEXP(-ZPLKA(LC+1)*TAUCPR(LC))*
     $              (ZPLK0(IQ,LC+1)+ZPLK1(IQ,LC+1)*TAUCPR(LC))
     $              -  DEXP(-ZPLKA(LC)*TAUCPR(LC))*
     $              (ZPLK0(IQ,LC)+ZPLK1(IQ,LC)*TAUCPR(LC))
           
 90         CONTINUE
 100     CONTINUE
C     
      ELSE IF ( FBEAM .GT. 0.0D0 .OR. il.GT.0 .OR. gsrc) THEN
C
         DO 150 IQ = 1, NN
C                                      ** TOP BOUNDARY
C
            B(IQ) =  - ZBEAM0(NN+1-IQ,1) - ZGEN0(NN+1-IQ,1)
     $           - ZPLK0(NN+1-IQ,1) +FISOT +TPLANK
         
 150     CONTINUE
C
         IF ( LYRCUT ) THEN
C
            DO 160 IQ = 1, NN
C                                      ** BOTTOM BOUNDARY
               B(NCOL-NN+IQ) = - DEXP(-ZBEAMA(NCUT)*TAUCPR(NCUT))*
     $              (ZBEAM0(IQ+NN,NCUT)+ZBEAM1(IQ+NN,NCUT)*TAUCPR(NCUT)
     $              )- DEXP(-ZPLKA(NCUT)*TAUCPR(NCUT))*(ZPLK0(IQ+NN,NCUT
     $              )+ZPLK1(IQ+NN,NCUT)*TAUCPR(NCUT))
     $              - DEXP(-ZGENA(NCUT)*TAUCPR(NCUT))*
     $              (ZGEN0(IQ+NN,NCUT)+ZGEN1(IQ+NN,NCUT)*TAUCPR(NCUT)
     $              )
            
 160        CONTINUE
C
         ELSE

            DO 180 IQ = 1, NN
C
               SUM = 0.D0
               DO 170 JQ = 1, NN
	          
                  SUM = SUM + CWT(JQ) * CMU(JQ) * ALBEDO
     $                 * ( 
     $                 DEXP(-ZBEAMA(NCUT)*TAUCPR(NCUT))*
     $                 (ZBEAM0(NN+1-JQ,NCUT)+ZBEAM1(NN+1-JQ,NCUT)
     $                 *TAUCPR(NCUT))+  
     $                 DEXP(-ZGENA(NCUT)*TAUCPR(NCUT))*
     $                 (ZGEN0(NN+1-JQ,NCUT)+ZGEN1(NN+1-JQ,NCUT)
     $                 *TAUCPR(NCUT))+  
     $                 DEXP(-ZPLKA(NCUT)*TAUCPR(NCUT))
     $                 *(ZPLK0(NN+1-JQ,NCUT)+ZPLK1(NN+1-JQ,NCUT)
     $                 *TAUCPR(NCUT)))
                 
 170           CONTINUE
              
              
               B(NCOL-NN+IQ) = 2.D0*SUM + ( ALBEDO * UMU0*FBEAM/PI
     $              ) *expbea(NCUT)
     $              + (1.D0-ALBEDO) * BPLANK
     $              -DEXP(-ZBEAMA(NCUT)*TAUCPR(NCUT))*
     $              (ZBEAM0(IQ+NN,NCUT)+
     $              ZBEAM1(IQ+NN,NCUT)*TAUCPR(NCUT))
     $              -DEXP(-ZGENA(NCUT)*TAUCPR(NCUT))*
     $              (ZGEN0(IQ+NN,NCUT)+
     $              ZGEN1(IQ+NN,NCUT)*TAUCPR(NCUT))
     $              -DEXP(-ZPLKA(NCUT)*TAUCPR(NCUT))*(ZPLK0(IQ+NN,NCUT)
     $              +ZPLK1(IQ+NN,NCUT)*TAUCPR(NCUT))
             	       
 180        CONTINUE
         END IF
C
         IT = NN
C                             ** CONTINUITY CONDITION FOR LAYER
C                             ** INTERFACES, STWJ(20B)
         DO 200  LC = 1, NCUT-1
            DO 190  IQ = 1, NSTR
               IT    = IT + 1
               B(IT) =
     $              +  DEXP(-ZBEAMA(LC+1)*TAUCPR(LC))*
     $              (ZBEAM0(IQ,LC+1)+ZBEAM1(IQ,LC+1)*TAUCPR(LC))
     $              -  DEXP(-ZBEAMA(LC)*TAUCPR(LC))*
     $              (ZBEAM0(IQ,LC)+ZBEAM1(IQ,LC)*TAUCPR(LC))
     $              +  DEXP(-ZGENA(LC+1)*TAUCPR(LC))*
     $              (ZGEN0(IQ,LC+1)+ZGEN1(IQ,LC+1)*TAUCPR(LC))
     $              -  DEXP(-ZGENA(LC)*TAUCPR(LC))*
     $              (ZGEN0(IQ,LC)+ZGEN1(IQ,LC)*TAUCPR(LC))
     $              +  DEXP(-ZPLKA(LC+1)*TAUCPR(LC))*
     $              (ZPLK0(IQ,LC+1)+ZPLK1(IQ,LC+1)*TAUCPR(LC))
     $              -  DEXP(-ZPLKA(LC)*TAUCPR(LC))*
     $              (ZPLK0(IQ,LC)+ZPLK1(IQ,LC)*TAUCPR(LC))
 190        CONTINUE
 200     CONTINUE
C     
      END IF
C
C                     ** FIND L-U (LOWER/UPPER TRIANGULAR) DECOMPOSITION
C                     ** OF BAND MATRIX -CBAND- AND TEST IF IT IS NEARLY
C                     ** SINGULAR (NOTE: -CBAND- IS DESTROYED)
C                     ** (-CBAND- IS IN LINPACK PACKED FORMAT)
      RCOND = 0.0D0
      NCD = 3*NN - 1
      CALL  dpSGBCO( CBAND, MI9M2, NCOL, NCD, NCD, IPVT, RCOND, Z )
      IF ( 1.0D0+RCOND .EQ. 1.0D0 )  CALL  ERRMSG
     $   ( 'ssolve0--SGBCO SAYS MATRIX NEAR SINGULAR',.FALSE.)
C
C                   ** SOLVE LINEAR SYSTEM WITH COEFF MATRIX -CBAND-
C                   ** AND R.H. SIDE(S) -B- AFTER -CBAND- HAS BEEN L-U
C                   ** DECOMPOSED.  SOLUTION IS RETURNED IN -B-.
C
      CALL  dpSGBSL( CBAND, MI9M2, NCOL, NCD, NCD, IPVT, B, 0 )
C
C                   ** ZERO -CBAND- (IT MAY CONTAIN 'FOREIGN'
C                   ** ELEMENTS UPON RETURNING FROM LINPACK);
C                   ** NECESSARY TO PREVENT ERRORS
C
      CALL  dpszeroit( CBAND, MI9M2*NNLYRI )
C
      DO 220  LC = 1, NCUT
         IPNT = LC*NSTR - NN
         DO 220  IQ = 1, NN
            LL(NN+1-IQ,LC) = B(IPNT+1-IQ)
            LL(IQ+NN,  LC) = B(IQ+IPNT)
220   CONTINUE

      RETURN
      END
*
      SUBROUTINE  dpqterpso( cwt, fbeam, gl, maz, mxcmu, noplnk,  
     $     numu, nstr, oprim, ylmc, ylmu, psi0, psi1, gsrc,
     $     xr0, xr1, xra, z0, z1, zbs0, zbs1, zbsa, zgs0, zgs1, zgsa, 
     $     zb0u, zb1u, zbau, zp0u, zp1u, zpau, zg0u, zg1u, zgau )   
C
C         INTERPOLATES SOURCE FUNCTIONS TO USER ANGLES
C
C    I N P U T      V A R I A B L E S:
C
C       CWT    :  WEIGHTS FOR GAUSS QUADRATURE OVER ANGLE COSINE
C       GL     :  DELTA-M SCALED LEGENDRE COEFFICIENTS OF PHASE FUNCTION
C                    (INCLUDING FACTORS 2L+1 AND SINGLE-SCATTER ALBEDO)
C       MAZ    :  ORDER OF AZIMUTHAL COMPONENT
C       OPRIM  :  SINGLE SCATTERING ALBEDO
C       XR0    :  EXPANSION OF THERMAL SOURCE FUNCTION
C       XR1    :  EXPANSION OF THERMAL SOURCE FUNCTION EQS.SS(14-16)
C       XR2    :  EXPANSION OF THERMAL SOURCE FUNCTION EQS.SS(14-16)
C       YLMC   :  NORMALIZED ASSOCIATED LEGENDRE POLYNOMIAL
C                 AT THE QUADRATURE ANGLES
C       YLMU   :  NORMALIZED ASSOCIATED LEGENDRE POLYNOMIAL
C                 AT THE USER ANGLES
C       Z0     :  SOLUTION VECTORS Z-SUB-ZERO OF EQ. SS(16)
C       Z1     :  SOLUTION VECTORS Z-SUB-ONE  OF EQ. SS(16)
C       ZJ     :  SOLUTION VECTOR CAPITAL -Z-SUB-ZERO AFTER SOLVING
C                 EQ. SS(19)
C       (REMAINDER ARE 'DISORT' INPUT VARIABLES)
*
*    O U T P U T     V A R I A B L E S:
*
*       zb0u, zb1u:  Incident-beam source function at user angles,
*        zbau        EXPonential-linear-in-optical-depth approximation.
*       zp0u, zp1u:  Components of a EXPonential-linear-in-optical-
*        zpau        depth-dependent source (approximating the 
*                    Planck emission source), at users angles.
C
C   I N T E R N A L       V A R I A B L E S:
C
C       PSI0,  :  SUM JUST AFTER SQUARE BRACKET IN  EQ. SD(9)
C        PSI1     WITH Z0 AND Z1 RESPECTIVELY
C+---------------------------------------------------------------------+
      implicit double precision (A-H, O-Z)
      LOGICAL  NOPLNK, gsrc
      real*8     CWT(*), GL(0:*), fbeam, oprim,
     $     PSI0(*), PSI1(*), xr0, xr1, xra,  
     $     YLMC( 0:MXCMU,* ), YLMU( 0:MXCMU,*), Z0(*), Z1(*), 
     $     zbs0(*), zbs1(*), zbsa, zgs0(*), zgs1(*), zgsa,
     $     zb0u(*), zb1u(*), zbau(*), zp0u(*), zp1u(*), zpau(*),
     $     zg0u(*), zg1u(*), zgau(*)
      real*8 psum0, psum1, sum0, sum1, gsum0, gsum1
C     
C
      IF ( FBEAM.GT.0.0 )  THEN
C                                  ** BEAM SOURCE TERMS; EQ. SD(9)
         DO 20  IQ = MAZ, NSTR-1
            psum0 = 0.D0
            psum1 = 0.D0
            DO 10  JQ = 1, NSTR
               psum0 = psum0 + cwt(jq) * ylmc(iq,jq) * zbs0(jq)
               psum1 = psum1 + cwt(jq) * ylmc(iq,jq) * zbs1(jq)
10          CONTINUE
            psi0(iq+1) = 0.5D0 * gl(iq) * psum0
            psi1(iq+1) = 0.5D0 * gl(iq) * psum1
20       CONTINUE
C
         DO 40  IU = 1, numu
            sum0 = 0.D0
            sum1 = 0.D0
            DO 30 IQ = MAZ, NSTR-1
               sum0 = sum0 + ylmu(iq,iu) * psi0(iq+1) 
               sum1 = sum1 + ylmu(iq,iu) * psi1(iq+1)
30          CONTINUE
            zb0u(iu) = sum0 + zb0u(iu)
            zb1u(iu) = sum1 + zb1u(iu)
            zbau(iu) = zbsa 
40       CONTINUE
      END IF
C
      IF ( gsrc )  THEN
C                                  ** General SOURCE TERMS; EQ. SD(9)
         DO 50  IQ = MAZ, NSTR-1
            gsum0 = 0.D0
            gsum1 = 0.D0
            DO 51  JQ = 1, NSTR
               gsum0 = gsum0 + cwt(jq) * ylmc(iq,jq) * zgs0(jq)
               gsum1 = gsum1 + cwt(jq) * ylmc(iq,jq) * zgs1(jq)
51          CONTINUE
            psi0(iq+1) = 0.5D0 * gl(iq) * gsum0
            psi1(iq+1) = 0.5D0 * gl(iq) * gsum1
50       CONTINUE
C
         DO 60  IU = 1, numu
            sum0 = 0.D0
            sum1 = 0.D0
            DO 61 IQ = MAZ, NSTR-1
               sum0 = sum0 + ylmu(iq,iu) * psi0(iq+1) 
               sum1 = sum1 + ylmu(iq,iu) * psi1(iq+1)
 61         CONTINUE
            zg0u(iu) = sum0 + zg0u(iu)
            zg1u(iu) = sum1 + zg1u(iu)
            zgau(iu) = zgsa 
60       CONTINUE
      END IF
C
      IF ( .NOT.NOPLNK .AND. MAZ.EQ.0 )  THEN
C
C                                ** THERMAL SOURCE TERMS, STWJ(27C)
         DO 80  IQ = MAZ, NSTR-1
            PSUM0 = 0.D0
            PSUM1 = 0.D0
            DO 70  JQ = 1, NSTR
               PSUM0 = PSUM0 + CWT(JQ) * YLMC(IQ,JQ) * Z0(JQ)
               PSUM1 = PSUM1 + CWT(JQ) * YLMC(IQ,JQ) * Z1(JQ)
 70         CONTINUE
            PSI0(IQ+1) = 0.5D0 * GL(IQ) * PSUM0
            PSI1(IQ+1) = 0.5D0 * GL(IQ) * PSUM1
 80       CONTINUE
C
          DO 100  IU = 1, numu
            SUM0 = 0.0D0
            SUM1 = 0.0D0
            DO 90   IQ = MAZ, NSTR-1
               SUM0 = SUM0 + YLMU(IQ,IU) * PSI0(IQ+1)
               SUM1 = SUM1 + YLMU(IQ,IU) * PSI1(IQ+1)
90          CONTINUE
            zp0u(iu) = sum0 + (1.D0-oprim) * xr0
            zp1u(iu) = sum1 + (1.D0-oprim) * xr1
            zpau(iu) = xra
100      CONTINUE
C
      END IF
C
      RETURN
      END
*
      SUBROUTINE dpqusrint( albedo, BPLANK, CMU, CWT, DELM0,EXPBEA,
     $     FBEAM, FISOT, GC, GU, il, KK, LAMBER, LAYRU, LL,
     $     LYRCUT, MAZ, MXCMU, MXULV, MXUMU, NCUT,
     $     NLYR, NN, NSTR, NOPLNK, NUMU, NTAU, PI, 
     $     TAUCPR, TPLANK, UMU, UMU0, UTAUPR, WK,
     $     zb0u, zb1u, zbau, zbeam0, zbeam1, zbeama,
     $     zp0u, zp1u, zpau, ZPLK0, ZPLK1, zplka, 
     $     zg0u, zg1u, zgau, zgena, zgen0, zgen1, 
     $     gsrc, uum, debug, prnt )
C
C       COMPUTES INTENSITY COMPONENTS AT USER OUTPUT ANGLES
C       FOR AZIMUTHAL EXPANSION TERMS IN EQ. SD(2)
C
C   I N P U T    V A R I A B L E S:
C
C       BPLANK :  INTEGRATED PLANCK FUNCTION FOR EMISSION FROM
C                 BOTTOM BOUNDARY
C       CMU    :  ABSCISSAE FOR GAUSS QUADRATURE OVER ANGLE COSINE
C       CWT    :  WEIGHTS FOR GAUSS QUADRATURE OVER ANGLE COSINE
C       DELM0  :  KRONECKER DELTA, DELTA-SUB-M0
C       emu    :  SURFACE DIRECTIONAL EMISSIVITY
C      expbea :  TRANSMISSION OF INCIDENT BEAM,DEXP(-TAUCPR/UMU0)
C       GC     :  EIGENVECTORS AT POLAR QUADRATURE ANGLES, SC(1)
C       GU     :  EIGENVECTORS INTERPOLATED TO USER POLAR ANGLES
C                 (i.e., g IN EQ. SC(1) )
C       KK     :  EIGENVALUES OF COEFF. MATRIX IN EQ. SS(7)
C       LAYRU  :  LAYER NUMBER OF USER LEVEL -UTAU-
C       LL     :  CONSTANTS OF INTEGsratioN IN EQ. SC(1), OBTAINED
C                 BY SOLVING SCALED VERSION OF EQ. SC(5);
C                 exponentIAL TERM OF EQ. SC(12) NOT INCLUDED
C       LYRCUT :  LOGICAL FLAG FOR TRUNCATION OF COMPUT. LAYER
C       MAZ    :  ORDER OF AZIMUTHAL COMPONENT
C       NCUT   :  TOTAL NUMBER OF COMPUTATIONAL LAYERS CONSIDERED
C       NN     :  ORDER OF DOUBLD-GAUSS QUADRATURE (NSTR/2)
C       rmu    :  SURFACE BIDIRECTIONAL REFLECTIVITY
C       TAUCPR :  CUMULATIVE OPTICAL DEPTH (DELTA-M-SCALED)
C       TPLANK :  INTEGRATED PLANCK FUNCTION FOR EMISSION FROM
C                 TOP BOUNDARY
C       UTAUPR :  OPTICAL DEPTHS OF USER OUTPUT LEVELS IN DELTA-M
C                    COORDINATES;  EQUAL TO  -UTAU- IF NO DELTA-M
C       zp0u   :  Z-SUB-ZERO IN EQ. SS(16) INTERPOLATED TO USER
C                 ANGLES FROM AN EQUATION DERIVED FROM SS(16)
C       zp1u   :  Z-SUB-ONE IN EQ. SS(16) INTERPOLATED TO USER
C                 ANGLES FROM AN EQUATION DERIVED FROM SS(16)
C       zp2u   :  Z-SUB-TWO IN EQ. SS(16) INTERPOLATED TO USER
C                 ANGLES FROM AN EQUATION DERIVED FROM SS(16)
C       ZPLK0  :  THERMAL SOURCE VECTORS -Z0-, BY SOLVING EQ. SS(16)
C       ZPLK1  :  THERMAL SOURCE VECTORS -Z1-, BY SOLVING EQ. SS(16)
C       zplka  :  THERMAL SOURCE VECTORS -Z2 , BY SOLVING EQ. SS(16)
C       ZBEAM  :  INCIDENT-BEAM SOURCE VECTORS
C       (REMAINDER ARE 'DISORT' INPUT VARIABLES)
C
C   O U T P U T    V A R I A B L E S:
C
C       UUM  :  AZIMUTHAL COMPONENTS OF THE INTENSITY IN EQ. STWJ(5)
C
C   I N T E R N A L    V A R I A B L E S:
C
C       BNDDIR :  DIRECT INTENSITY DOWN AT THE BOTTOM BOUNDARY
C       BNDDFU :  DIFFUSE INTENSITY DOWN AT THE BOTTOM BOUNDARY
C       BNDINT :  INTENSITY ATTENUATED AT BOTH BOUNDARIES, STWJ(25-6)
C       DTAU   :  OPTICAL DEPTH OF A COMPUTATIONAL LAYER
C       LYREND :  END LAYER OF INTEGRATION
C       LYRSTR :  START LAYER OF INTEGRATION
C       PALINT :  INTENSITY COMPONENT FROM PARALLEL BEAM
C       PLKINT :  INTENSITY COMPONENT FROM PLANCK SOURCE
C       WK     :  SCRATCH VECTOR FOR SAVING 'EXP' EVALUATIONS
C       ALL THE exponentIAL FACTORS ( exp1, expn,... etc.)
C       COME FROM THE SUBSTITUTION OF CONSTANTS OF INTEGsratioN IN
C       EQ. SC(12) INTO EQS. S1(8-9).  THEY ALL HAVE NEGATIVE
C       ARGUMENTS SO THERE SHOULD NEVER BE OVERFLOW PROBLEMS.
C+---------------------------------------------------------------------+
C
      implicit double precision (A-H, O-Z)
      LOGICAL  LAMBER, LYRCUT, NOPLNK, NEGUMU, gsrc
      LOGICAL debug, prnt(*)
      INTEGER  LAYRU(*)
      real*8     albedo, bplank, CMU(*), CWT(*), delm0, denom, 
     $     dtau, dtau1, dtau2,expbea(0:*), fbeam, fisot,
     $     GC( MXCMU,MXCMU,* ),
     $     GU( MXUMU,MXCMU,* ), KK( MXCMU,* ), LL( MXCMU,* ),
     $     pi, TAUCPR( 0:* ), tplank, uum( mxumu,mxulv, 0:* ),
     $     UMU(*), umu0, UTAUPR(*), WK(*),
     $     zb0u( mxumu,* ), zb1u( mxumu,* ), zbau( mxumu,* ),
     $     zg0u( mxumu,* ), zg1u( mxumu,* ), zgau( mxumu,* ),
     $     zp0u( mxumu,* ), zp1u( mxumu,* ), zpau( mxumu,* ),
     $     zbeam0( mxcmu,* ), zbeam1( mxcmu,* ), zbeama( * ),
     $     zgen0( mxcmu,* ), zgen1( mxcmu,* ), zgena( * ),
     $     ZPLK0( MXCMU,* ), ZPLK1( MXCMU,* ), zplka( * ) 
      real*8 alfa, bnddfu, bnddir, bndint, dfuint,
     $     emu, exp1, exp2, expn, palint, plkint, rmu, sgn
C
C
      CALL  dpszeroit( UUM, MXUMU*MXULV*(mxcmu+1) )
    
      emu = 1.d0 - albedo
      rmu = albedo 
C                          ** INCORPORATE CONSTANTS OF INTEGRATION INTO
C                          ** INTERPOLATED EIGENVECTORS
      DO 10  LC = 1, NCUT
         DO  10  IQ = 1, NSTR
            DO 10  IU = 1, NUMU 
               GU(IU,IQ,LC) = GU(IU,IQ,LC)* LL(IQ,LC)
              
10    CONTINUE
      
C                           ** LOOP OVER LEVELS AT WHICH INTENSITIES
C                           ** ARE DESIRED ('USER OUTPUT LEVELS')
      DO 200  LU = 1, NTAU
C
         LYU = LAYRU(LU)
C                              ** LOOP OVER POLAR ANGLES AT WHICH
C                              ** INTENSITIES ARE DESIRED
         DO 100  IU = 1, NUMU
            
            IF ( LYRCUT .AND. LYU.GT.NCUT )  GO TO 100
            NEGUMU = UMU(IU).LT.0.0D0
            IF( NEGUMU )  THEN
               LYRSTR = 1
               LYREND = LYU - 1
               SGN = - 1.0D0
            ELSE
               LYRSTR = LYU + 1
               LYREND = NCUT
               SGN = 1.0D0
            END IF
C                          ** FOR DOWNWARD INTENSITY, INTEGRATE FROM TOP
C                          ** TO 'LYU-1' IN EQ. S1(8); FOR UPWARD,
C                          ** INTEGRATE FROM BOTTOM TO 'LYU+1' IN S1(9)
            PALINT = 0.0D0
            PLKINT = 0.0D0
            genint = 0.0D0

            DO 30  LC = LYRSTR, LYREND
C             
               DTAU = TAUCPR(LC) - TAUCPR(LC-1)
C	         
               exp1 = DEXP( (UTAUPR(LU) - TAUCPR(LC-1)) / UMU(IU) )
               exp2 = DEXP( (UTAUPR(LU) - TAUCPR( LC )) / UMU(IU) )
C
                 
               IF ( .NOT.NOPLNK .AND. MAZ.EQ.0 ) THEN
                 denom  =  SGN*1.D0/(zpau(iu,lc)*UMU(IU)+1.D0)
                 PLKINT = PLKINT +
     $                    (zp0u(iu,lc)*denom*
     $                        (DEXP(-zpau(iu,lc)*TAUCPR(LC-1)) *EXP1
     $                        -DEXP(-zpau(iu,lc)*TAUCPR(LC)) *EXP2 )
     $                    +zp1u(iu,lc)*denom*
     $                        ( (TAUCPR(LC-1)+SGN*denom*UMU(IU) )
     $                        *DEXP(-zpau(iu,lc)*TAUCPR(LC-1)) *EXP1
     $                         -(TAUCPR(LC)+SGN*denom*UMU(IU) )
     $                      *DEXP(-zpau(iu,lc)*TAUCPR(LC))* exp2) )
               ENDIF
C
         
	       IF ( FBEAM.GT.0.0 .OR. il.GT.0 )  THEN
		 denom  =  SGN*1.D0/(zbau(iu,lc)*UMU(IU)+1.D0)
		
		 palint = palint +
     $  		 ( zb0u(iu,lc)*denom*
     $  		     (DEXP(-zbau(iu,lc)*TAUCPR(LC-1)) *EXP1
     $  		     -DEXP(-zbau(iu,lc)*TAUCPR(LC)) *EXP2 ) 
     $  		+zb1u(iu,lc)*denom*
     $  		    ( (TAUCPR(LC-1)+SGN*denom*UMU(IU) )
     $  		   *DEXP(-zbau(iu,lc)*TAUCPR(LC-1)) *EXP1
     $  		     -(TAUCPR(LC)+SGN*denom*UMU(IU) )
     $  		   *DEXP(-zbau(iu,lc)*TAUCPR(LC))* exp2) )
               ENDIF

	       IF ( gsrc )  THEN
		 denom  =  SGN*1.D0/(zgau(iu,lc)*UMU(IU)+1.D0)
		
		 genint = genint +
     $  		 ( zg0u(iu,lc)*denom*
     $  		     (DEXP(-zgau(iu,lc)*TAUCPR(LC-1)) *EXP1
     $  		     -DEXP(-zgau(iu,lc)*TAUCPR(LC)) *EXP2 ) 
     $  		+zg1u(iu,lc)*denom*
     $  		    ( (TAUCPR(LC-1)+SGN*denom*UMU(IU) )
     $  		   *DEXP(-zgau(iu,lc)*TAUCPR(LC-1)) *EXP1
     $  		     -(TAUCPR(LC)+SGN*denom*UMU(IU) )
     $  		   *DEXP(-zgau(iu,lc)*TAUCPR(LC))* exp2) )
                 
               ENDIF
               
C                                                   ** -KK- IS NEGATIVE
 1715          DO 20  IQ = 1, NN
                  WK(IQ) = DEXP( KK(IQ,LC) * DTAU )
		  
                  DENOM = 1.d0 + UMU(IU) * KK(IQ,LC)

                  IF ( DABS(DENOM).LT.0.0001D0 ) THEN
C                                                   ** L'HOSPITAL LIMIT
                     expn = DTAU / UMU(IU) * exp2
		    
                  ELSE
                     expn = SGN * ( exp1 * WK(IQ) - exp2 ) / DENOM

                  END IF

                  PALINT = PALINT + GU(IU,IQ,LC) * expn
 20            CONTINUE
               
C  ** -KK- IS POSITIVE
                 
               DO 21  IQ = NN+1, NSTR
                  DENOM = 1.0D0 + UMU(IU) * KK(IQ,LC)
		 
                  IF (DABS(DENOM).LT.0.0001D0) THEN
C                                                   ** L'HOSPITAL LIMIT
                     expn = - DTAU / UMU(IU) * exp1
		    
		   
                  ELSE
                     expn = SGN *( exp1 - exp2 * WK(NSTR+1-IQ) ) / DENOM
                  END IF
		 
                  PALINT = PALINT + GU(IU,IQ,LC) * expn

21             CONTINUE
C
 30         CONTINUE
C                           ** CALCULATE CONTRIBUTION FROM USER
C                           ** OUTPUT LEVEL TO NEXT COMPUTATIONAL LEVEL
C
            DTAU1 = UTAUPR(LU) - TAUCPR(LYU-1)
            DTAU2 = UTAUPR(LU) - TAUCPR(LYU)
            IF(DABS(DTAU1).LT.1.D-6 .AND. NEGUMU ) then
	       GO TO 50
	    endif
            IF(DABS(DTAU2).LT.1.D-6 .AND. (.NOT.NEGUMU) )then
	       GO TO 50
	    endif
            IF( NEGUMU ) then
	       exp1 = DEXP( DTAU1 / UMU(IU) )
	     
	    endif   
            IF( .NOT.NEGUMU) then	   
	       exp2 = DEXP( DTAU2 / UMU(IU) )
	    endif   
	   
C
            IF ( FBEAM.GT.0.0 .OR. il.GT.0 )  THEN
               IF ( NEGUMU ) THEN
                  expn = exp1
                  ALFA = zbau(iu,lyu)
                  denom = (-1.D0/(ALFA*UMU(IU)+1.D0))
                  
                  palint = palint + 
     $                 zb0u(iu,lyu)*denom*
     $                 (-DEXP(-ALFA*UTAUPR(LU))
     $                 + expn*DEXP(-alfa*taucpr(lyu-1)) )
     $  	       +  zb1u(iu,lyu)*denom*
     $                 ( -(UTAUPR(LU)-UMU(IU)*denom)*
     $                 DEXP(-ALFA*UTAUPR(LU))
     $  			+(TAUCPR(LYU-1)-UMU(IU)*denom) 
     $                 *EXPN*DEXP(-alfa*taucpr(lyu-1)) )
                  
               ELSE
                  expn = exp2
                  ALFA = zbau(iu,lyu)
                  denom = (1.D0/(ALFA*UMU(IU)+1.D0))
                  palint = palint + 
     $                 zb0u(iu,lyu)*denom*
     $  		      (DEXP(-ALFA*UTAUPR(LU))
     $  		       -DEXP(-ALFA*TAUCPR(LYU))*EXPN)
     $  	       +  zb1u(iu,lyu)*denom*
     $  		      ( (UTAUPR(LU) +UMU(IU)*denom)
     $  			 *DEXP(-ALFA*UTAUPR(LU))
     $  		       -(TAUCPR(LYU)+UMU(IU)*denom)
     $  			 *DEXP(-ALFA*TAUCPR(LYU)) *EXPN )
	          
               ENDIF
            ENDIF
            IF ( gsrc )  THEN
              IF ( NEGUMU ) THEN
                 expn = exp1
                 ALFA = zgau(iu,lyu)
                 denom = (-1.D0/(ALFA*UMU(IU)+1.D0))
	        
                 genint = genint + 
     $                    zg0u(iu,lyu)*denom*
     $  		       (-DEXP(-ALFA*UTAUPR(LU))
     $  			+ expn*DEXP(-alfa*taucpr(lyu-1)) )
     $  	       +  zg1u(iu,lyu)*denom*
     $  		      ( -(UTAUPR(LU)-UMU(IU)*denom)*
     $  			DEXP(-ALFA*UTAUPR(LU))
     $  			+(TAUCPR(LYU-1)-UMU(IU)*denom) 
     $  			*EXPN*DEXP(-alfa*taucpr(lyu-1)) )

	      ELSE
		 expn = exp2
		 ALFA = zgau(iu,lyu)
		 denom = (1.D0/(ALFA*UMU(IU)+1.D0))
		 genint = genint + 
     $  		  zg0u(iu,lyu)*denom*
     $  		      (DEXP(-ALFA*UTAUPR(LU))
     $  		       -DEXP(-ALFA*TAUCPR(LYU))*EXPN)
     $  	       +  zg1u(iu,lyu)*denom*
     $  		      ( (UTAUPR(LU) +UMU(IU)*denom)
     $  			 *DEXP(-ALFA*UTAUPR(LU))
     $  		       -(TAUCPR(LYU)+UMU(IU)*denom)
     $  			 *DEXP(-ALFA*TAUCPR(LYU)) *EXPN )
	          
	      ENDIF
            ENDIF
	    
C                                                   ** -KK- IS NEGATIVE
            DTAU = TAUCPR(LYU) - TAUCPR(LYU-1)
            DO 40  IQ = 1, NN
               DENOM = 1.D0 + UMU(IU) * KK(IQ,LYU)
               IF (DABS(DENOM).LT.0.0001D0 ) THEN
                  expn = - DTAU2 / UMU(IU) * exp2
		 
               ELSE IF ( NEGUMU ) THEN
                  expn = ( DEXP( - KK(IQ,LYU) * DTAU2 ) -
     $                   DEXP( KK(IQ,LYU) * DTAU ) * exp1 ) / DENOM
               ELSE
                  expn = (DEXP( - KK(IQ,LYU) * DTAU2 ) - exp2 ) / DENOM
               END IF
               PALINT = PALINT + GU(IU,IQ,LYU) * expn
	       
40          CONTINUE
C                                                   ** -KK- IS POSITIVE
	    
            DO 41  IQ = NN+1, NSTR
               DENOM = 1.D0 + UMU(IU) * KK(IQ,LYU)
               IF (DABS(DENOM).LT.0.0001D0 ) THEN
                  expn = - DTAU1 / UMU(IU) * exp1
		 
               ELSE IF ( NEGUMU ) THEN
                  expn = (DEXP(- KK(IQ,LYU) * DTAU1 ) - exp1 ) / DENOM
               ELSE
                  expn = (DEXP( - KK(IQ,LYU) * DTAU1 ) -
     $                    DEXP( - KK(IQ,LYU) * DTAU ) * exp2 ) / DENOM
               END IF
               PALINT = PALINT + GU(IU,IQ,LYU) * expn
	  
41          CONTINUE
C
    
            IF ( .NOT.NOPLNK .AND. MAZ.EQ.0 )  THEN
              IF ( NEGUMU ) THEN
                 expn = exp1
                 ALFA = zpau(iu,lyu)
                 denom = (-1.D0/(ALFA*UMU(IU)+1.D0))
                 PLKINT = PLKINT + 
     $                    zp0u(iu,lyu)*denom*
     $                        (-DEXP(-ALFA*UTAUPR(LU))
     $                        + expn*DEXP(-alfa*taucpr(lyu-1)) )
     $                 +  zp1u(iu,lyu)*denom*
     $                        ( -(UTAUPR(LU)-UMU(IU)*denom)*
     $                            DEXP(-ALFA*UTAUPR(LU))
     $                          +(TAUCPR(LYU-1)-UMU(IU)*denom) 
     $                           *EXPN*DEXP(-alfa*taucpr(lyu-1)) )
              ELSE
                 expn = exp2
                 ALFA = zpau(iu,lyu)
                 denom = (1.D0/(ALFA*UMU(IU)+1.D0))
                 PLKINT = PLKINT + 
     $                    zp0u(iu,lyu)*denom*
     $                        (DEXP(-ALFA*UTAUPR(LU))
     $                          -DEXP(-ALFA*TAUCPR(LYU))*EXPN)
     $                 +  zp1u(iu,lyu)*denom*
     $                        ( (UTAUPR(LU) +UMU(IU)*denom)
     $                           *DEXP(-ALFA*UTAUPR(LU))
     $                         -(TAUCPR(LYU)+UMU(IU)*denom)
     $                          *DEXP(-ALFA*TAUCPR(LYU)) *EXPN )
              END IF
            END IF
C                            ** CALCULATE INTENSITY COMPONENTS
C                            ** ATTENUATED AT BOTH BOUNDARIES.
C                            ** NOTE:: NO AZIMUTHAL INTENSITY
C                            ** COMPONENT FOR ISOTROPIC SURFACE
50          BNDINT = 0.0D0
            IF ( il .EQ. 0 ) THEN
               IF ( NEGUMU .AND. MAZ.EQ.0 ) THEN
                  BNDINT = ( FISOT + TPLANK ) * DEXP( UTAUPR(LU) /
     $                 UMU(IU) )
               ELSE IF ( .NOT.NEGUMU ) THEN
                  IF ( LYRCUT .OR. (LAMBER .AND. MAZ.GT.0) )  GO TO 90
                  DO 60  JQ = NN+1, NSTR
                     WK(JQ) = DEXP(-KK(JQ,NLYR)*
     $                    (TAUCPR(NLYR)-TAUCPR(NLYR-1)))
 60               CONTINUE
                  BNDDFU = 0.D0
                  DO 80  IQ = NN, 1, -1
                     DFUINT = 0.D0
                     DO 70  JQ = 1, NN
                        DFUINT = DFUINT + GC(IQ,JQ,NLYR) * LL(JQ,NLYR)
 70                  CONTINUE
                     DO 71  JQ = NN+1, NSTR
                        DFUINT = DFUINT + GC(IQ,JQ,NLYR) * LL(JQ,NLYR)
     $                       * WK(JQ)
 71                  CONTINUE
                     IF ( FBEAM.GT.0.D0 )
     $                    DFUINT = DFUINT + 
     $                    DEXP(-zbeama(nlyr)*taucpr(nlyr)) *
     $                    (zbeam0(iq,nlyr)+
     $                    zbeam1(iq,nlyr)*taucpr(nlyr))
                     IF ( gsrc )  THEN
                        DFUINT = DFUINT + 
     $                       DEXP(-zgena(nlyr)*taucpr(nlyr)) *
     $                       (zgen0(iq,nlyr)+
     $                       zgen1(iq,nlyr)*taucpr(nlyr))
                     ENDIF
                     DFUINT = DFUINT + DELM0 * ( 
     $                    DEXP(-zplka(nlyr)*TAUCPR(NLYR))*
     $                    (ZPLK0(IQ,NLYR)+
     $                    ZPLK1(IQ,NLYR)*TAUCPR(NLYR)))
                     BNDDFU = BNDDFU + ( 1.D0 + DELM0 ) * rmu
     $                    * CMU(NN+1-IQ) * CWT(NN+1-IQ) * DFUINT
 80               CONTINUE
C     
                  BNDDIR = 0.0D0
                  IF (FBEAM.GT.0.0D0  .OR. umu0.GT.0 ) BNDDIR = UMU0
     $                 * FBEAM / PI * rmu *expbea(NLYR)
                  BNDINT = ( BNDDFU + BNDDIR + DELM0 * emu * BPLANK )
     $                 *DEXP( (UTAUPR(LU)-TAUCPR(NLYR)) / UMU(IU) )
                 
               END IF
            END IF
C
 90         UUM( IU, LU, maz ) =  PALINT+PLKINT+genint + BNDINT
	  
C
100     CONTINUE
200   CONTINUE
C
      RETURN
      END
*
      SUBROUTINE dpPRTINT( UU, UTAU, NTAU, UMU, NUMU, PHI, NPHI, MAXULV,
     &                   MAXUMU )

c         Prints the intensity at user polar and azimuthal angles

c     All arguments are DISORT input or output variables

c   Called by- DISORT

c     LENFMT   Max number of azimuth angles PHI that can be printed
c                on one line, as set in FORMAT statement
c +-------------------------------------------------------------------+

c     .. Scalar Arguments ..

      INTEGER   MAXULV, MAXUMU, NPHI, NTAU, NUMU
c     ..
c     .. Array Arguments ..

      REAL*8      PHI( * ), UMU( * ), UTAU( * ), UU( MAXUMU, MAXULV, * )
c     ..
c     .. Local Scalars ..

      INTEGER   IU, J, JMAX, JMIN, LENFMT, LU, NP, NPASS
c     ..
c     .. Intrinsic Functions ..

      INTRINSIC MIN
c     ..


      IF( NPHI.LT.1 )  RETURN

      WRITE( *, '(//,A)' )
     &   ' *********  I N T E N S I T I E S  *********'

      LENFMT = 10
      NPASS  = 1 + (NPHI-1) / LENFMT

      WRITE( *, '(/,A,/,A,/,A)' )
     &   '             Polar   Azimuth angles (degrees)',
     &   '   Optical   Angle',
     &   '    Depth   Cosine'

      DO 30 LU = 1, NTAU

         DO 20 NP = 1, NPASS

            JMIN   = 1 + LENFMT * ( NP - 1 )
            JMAX   = MIN( LENFMT*NP, NPHI )

            WRITE( *, '(/,18X,10F11.2)' ) ( PHI(J), J = JMIN, JMAX )

            IF( NP.EQ.1 ) WRITE( *, '(F10.4,F8.4,1P,10E11.3)' )
     &             UTAU(LU), UMU(1), (UU(1, LU, J), J = JMIN, JMAX)
            IF( NP.GT.1 ) WRITE( *, '(10X,F8.4,1P,10E11.3)' )
     &                       UMU(1), (UU(1, LU, J), J = JMIN, JMAX)

            DO 10 IU = 2, NUMU
               WRITE( *, '(10X,F8.4,1P,10E11.3)' ) 
     &                 UMU( IU ), ( UU( IU, LU, J ), J = JMIN, JMAX )
   10       CONTINUE

   20    CONTINUE

   30 CONTINUE


      RETURN
      END
